#version 120

//disabling is done by adding "//" to the beginning of a line.

//***************************ADJUSTABLE VARIABLES//***************************
//***************************ADJUSTABLE VARIABLES//***************************
//***************************ADJUSTABLE VARIABLES//***************************

//***************************SHADOWS***************************//
const int 		shadowMapResolution 	= 2048;			//shadowmap resolution
const float 	shadowDistance 			= 100.0f;		//draw distance of shadows

#define SHADOW_DARKNESS 0.3	//shadow darkness levels, lower values mean darker shadows, see .vsh for colors 

#define SHADOW_FILTER						//smooth shadows
	#define SHADOW_FILTER_AMOUNT 1.0
	//#define LQ_SHADOW_FILTER
	#define HQ_SHADOW_FILTER

//***************************LIGHTNING***************************//
	#define DYNAMIC_HANDLIGHT	
		#define HANDLIGHT_AMOUNT 1.0
	
	#define SUNLIGHTAMOUNT 0.75		//change sunlight strength , see .vsh for colors.
	
	//Torch Color//
	#define TORCH_COLOR 0.3,0.075,0.01		//RGB - Red, Green, Blue / vec3(0.6,0.32,0.1) is default
	#define TORCH_ATTEN 3.0					//how much the torch light will be attenuated (decrease if you want the torches to cover a bigger area)
	#define TORCH_INTENSITY 0.75		
	
	//Minecraft lightmap (used for sky)
	#define ATTENUATION 1.2
	#define MIN_LIGHT 0.003

//***************************VISUALS***************************//
	#define GODRAYS
	const float density = .8;			
	const int NUM_SAMPLES = 5;			//increase this for better quality at the cost of performance 
	const float grnoise = 1;		//amount of noise 
	
	//#define CELSHADING
		#define BORDER 1.0
		
	#define CLOUDS
	
	//#define SSAO		                  					
	const int nbdir = 6;	           //qualtiy		
	const float sampledir = 6;	      //quality
	const float ssaorad = 1.5;	 //strength

	#define WATER_REFRACT
		#define REFRACT_MULT 6.0
	
	#define WATER_CAUSTIC
		#define CAUSTIC_STRENGHT 1.0
		#define CAUSTIC_SIZE 1.0
		#define CAUSTIC_SPEED 1.0

//***************************BUILD IN FUNCTIONS***************************//

const float 	wetnessHalflife 		= 70.f;
const float 	drynessHalflife 		= 70.f;

const float 	eyeBrightnessHalflife 	= 8.f;
const float 	centerDepthHalflife 	= 4.f;

const bool 		shadowHardwareFiltering = false;
const float 	shadowIntervalSize 		= 10.f;

const float		sunPathRotation			= -30.f;

const float		ambientOcclusionLevel	= 1.f; 

const int 		R8						= 1;
const int 		RG8						= 1;
const int 		RA8 					= 1;
const int 		RGA8 					= 1;
const int 		RGB8					= 1;
const int 		RGBA8 					= 1;
const int 		RGB16 					= 1;
const int 		RGBA16 					= 1;

const int 		gdepthFormat 			= RGB8;
const int 		gdepthtexFormat 		= RGB8;
const int 		gcolorFormat 			= RGBA8;
const int 		gnormalFormat 			= RGB16;

const int 		compositeFormat 		= RGBA16;

const int 		gaux1Format 			= RGB8;
const int 		gaux2Format 			= RGBA16;
const int 		gaux3Format 			= RGB8;
const int 		gaux4Format 			= RGBA8;

const int 		noiseTextureResolution  = 1024;

//***************************END OF BUILD IN FUNCTIONS***************************//

//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//

#define SHADOW_MAP_BIAS 0.8

varying vec4 texcoord;
varying vec4 lightS;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight_color;
varying vec3 ambient_color;
varying vec3 moonlight;
varying vec3 sunlight;

varying float handItemLight;
varying float eyeAdapt;

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

uniform sampler2D gcolor;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D depthtex2;
uniform sampler2D depthtex3;
uniform sampler2D depthtex4;
uniform sampler2D gnormal;
uniform sampler2D gdepth;
uniform sampler2D gdepthtex;
uniform sampler2D shadow;
uniform sampler2D gaux1;
uniform sampler2D gaux2;
uniform sampler2D gaux3;
uniform sampler2D noisetex;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferModelView;

uniform mat4 shadowProjection;
uniform mat4 shadowModelView;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;

uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float aspectRatio;
uniform float frameTimeCounter;
uniform float centerDepthSmooth;

uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;

uniform int isEyeInWater;
uniform int worldTime;
uniform int fogMode;

	float timefract = worldTime;

	float TimeSunrise  = ((clamp(timefract, 23000.0f, 25000.0f) - 23000.0f) / 1000.0f) + (1.0f - (clamp(timefract, 0.0f, 2000.0f)/2000.0f));
	float TimeNoon     = ((clamp(timefract, 0.0f, 2000.0f)) / 2000.0f) - ((clamp(timefract, 9000.0f, 12000.0f) - 9000.0f) / 3000.0f);
	float TimeSunset   = ((clamp(timefract, 9000.0f, 12000.0f) - 9000.0f) / 3000.0f) - ((clamp(timefract, 12000.0f, 12750.0f) - 12000.0f) / 750.0f);
	float TimeMidnight = ((clamp(timefract, 12000.0f, 12750.0f) - 12000.0f) / 750.0f) - ((clamp(timefract, 23000.0f, 24000.0f) - 23000.0f) / 1000.0f);

float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;

float cdist(vec2 coord){
    return distance(coord,vec2(0.5))*2.0;
}

vec3 convertScreenSpaceToWorldSpace(vec2 co, float depth) {
    vec4 fragposition = gbufferProjectionInverse * vec4(vec3(co, depth) * 2.0 - 1.0, 1.0);
    fragposition /= fragposition.w;
    return fragposition.xyz;
}

vec3 convertCameraSpaceToScreenSpace(vec3 cameraSpace) {
    vec4 clipSpace = gbufferProjection * vec4(cameraSpace, 1.0);
    vec3 NDCSpace = clipSpace.xyz / clipSpace.w;
    vec3 screenSpace = 0.5 * NDCSpace + 0.5;
    return screenSpace;
}

float edepth(vec2 coord) {
	return texture2D(gdepthtex,coord).z;
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}

vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}

vec3 aux = texture2D(gaux1, texcoord.st).rgb;
vec3 sunPos = sunPosition;

vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0f - 1.0f;

vec3 fragpos = vec3(texcoord.st, texture2D(gdepthtex, texcoord.st).r);

float pixeldepth = texture2D(depthtex0,texcoord.xy).x;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float shadowexit = 0.0;

float handlight = handItemLight*0.5*HANDLIGHT_AMOUNT;
const float speed = 2.5;
float light_jitter = 1.0-sin(frameTimeCounter*1.4*speed+cos(frameTimeCounter*1.9*speed))*0.05;			//little light variations
float torch_lightmap = pow(aux.b*light_jitter,TORCH_ATTEN)*TORCH_INTENSITY;

float getCloudNoiseTex(vec4 fragpos, float x, float y, float z) {

    vec4 wrldpos = ((gbufferModelViewInverse) * fragpos / far * 128*(1.0-rainx*0.9));

    float common = (wrldpos.y + length(wrldpos.y))/100, t = frameTimeCounter;  
    float f = 0.2, frq = 1.0, ap = 0.5*(1.0-rainx*-5.0);

    vec2 wind = vec2(1+t, 8+t)/(y*10.0), camPos = (wrldpos.xz*z/wrldpos.y);
    vec2 pos = -1+0.01*(camPos + wind/y); pos /= x/y;

    f += texture2D(noisetex, pos*frq - frameTimeCounter/32000).x*ap; frq *= 5.0; ap *= 0.05;
    f += texture2D(noisetex, pos*frq - frameTimeCounter/34000).x*ap; frq *= 2.1; ap *= 1.5;
    f += texture2D(noisetex, pos*frq - frameTimeCounter/36000).x*ap; frq *= 2.4; ap *= 0.5;
    f += texture2D(noisetex, pos*frq - frameTimeCounter/38000).x*ap; frq *= 2.9; ap *= 0.5;
	f += texture2D(noisetex, pos*frq - frameTimeCounter/40000).x*ap; frq *= 2.1; ap *= 0.5;
	

    f /= 0.58; float tex = f, b = 0.9, c = tex - (b+0.175);
    if(c <= 0) c = 0; tex = ((1.0 - pow(b, c))*common);

    float getCloudNoiseTex = tex;

    return getCloudNoiseTex;
}		

float sky_lightmap = pow(aux.r,ATTENUATION);
	float iswet = wetness*pow(sky_lightmap,5.0)*sqrt(0.5+max(dot(normal,normalize(upPosition)),0.0));
	
	vec3 specular = texture2D(gaux3,texcoord.xy).rgb;
	float specmap = specular.r*(1.0-specular.b)+specular.g*iswet+specular.b*0.85;
	
//poisson distribution for shadow sampling		

const vec2 circle_offsets[30] = vec2[30]  (  vec2( 0.0000, 0.2500 ),
         vec2( -0.2165, 0.1250 ),
         vec2( -0.2165, -0.1250 ),
         vec2( -0.0000, -0.2500 ),
         vec2( 0.2165, -0.1250 ),
         vec2( 0.2165, 0.1250 ),
         vec2( 0.0000, 0.5000 ),
         vec2( -0.2500, 0.4330 ),
         vec2( -0.4330, 0.2500 ),
         vec2( -0.5000, 0.0000 ),
         vec2( -0.4330, -0.2500 ),
         vec2( -0.2500, -0.4330 ),
         vec2( -0.0000, -0.5000 ),
         vec2( 0.2500, -0.4330 ),
         vec2( 0.4330, -0.2500 ),
         vec2( 0.5000, -0.0000 ),
         vec2( 0.4330, 0.2500 ),
         vec2( 0.2500, 0.4330 ),
         vec2( 0.0000, 0.7500 ),
         vec2( -0.2565, 0.7048 ),
         vec2( -0.4821, 0.5745 ),
         vec2( -0.6495, 0.3750 ),
         vec2( -0.7386, 0.1302 ),
         vec2( -0.7386, -0.1302 ),
         vec2( -0.6495, -0.3750 ),
         vec2( -0.4821, -0.5745 ),
         vec2( -0.2565, -0.7048 ),
         vec2( -0.0000, -0.7500 ),
         vec2( 0.2565, -0.7048 ),
         vec2( 0.4821, -0.5745 ));

const vec2 cross_offset[36] = vec2[36]  (  vec2( 0.0, 0.1 ),
		vec2( 0.0, 0.15 ),
        vec2( 0.0, 0.2 ),
		vec2( 0.0, 0.25 ),
        vec2( 0.0, 0.3 ),
		vec2( 0.0, 0.35 ),
		vec2( 0.0, 0.4 ),
		vec2( 0.0, 0.45 ),
		vec2( 0.0, 0.5 ),
		vec2( -0.1, 0.0 ),
		vec2( -0.15, 0.0 ),
		vec2( -0.2, 0.0 ),
		vec2( -0.25, 0.0 ),
		vec2( -0.3, 0.0 ),
		vec2( -0.35, 0.0 ),
		vec2( -0.4, 0.0 ),
		vec2( -0.45, 0.0 ),
		vec2( -0.5, 0.0 ),
		vec2( 0.0, -0.1 ),
		vec2( 0.0, -0.15 ),
		vec2( 0.0, -0.2 ),
		vec2( 0.0, -0.25 ),
		vec2( 0.0, -0.3 ),
		vec2( 0.0, -0.35 ),
		vec2( 0.0, -0.4 ),
		vec2( 0.0, -0.45 ),
		vec2( 0.0, -0.5 ),
		vec2( 0.1, 0.0 ),
		vec2( 0.15, 0.0 ),
		vec2( 0.2, 0.0 ),
		vec2( 0.25, 0.0 ),
		vec2( 0.3, 0.0 ),
		vec2( 0.35, 0.0 ),
		vec2( 0.4, 0.0 ),
		vec2( 0.45, 0.0 ),
		vec2( 0.5, 0.0 ));

float ctorspec(vec3 ppos, vec3 lvector, vec3 normal,float rough,float fpow) {
    //half vector
	vec3 pos = -normalize(ppos);
    vec3 cHalf = normalize(lvector + pos);
	
    // beckman's distribution function D
    float normalDotHalf = dot(normal, cHalf);
    float normalDotHalf2 = normalDotHalf * normalDotHalf;

    float roughness2 = rough;
    float exponent = -(1.0 - normalDotHalf2) / (normalDotHalf2 * roughness2);
    float e = 2.71828182846;
    float D = pow(e, exponent) / (roughness2 * normalDotHalf2 * normalDotHalf2);
	
    // fresnel term F
	float normalDotEye = dot(normal, pos);
    float F = pow(1.0 - normalDotEye, fpow);

    // self shadowing term G
    float normalDotLight = dot(normal, lvector);
    float X = 2.0 * normalDotHalf / dot(pos, cHalf);
    float G = min(1.0, min(X * normalDotLight, X * normalDotEye));
    float pi = 3.1415927;
    float CookTorrance = (D*F*G)/(pi*normalDotEye);
	
    return max(CookTorrance/pi,0.0);
}

float Blinn_Phong(vec3 ppos, vec3 lvector, vec3 normal,float fpow, float gloss, float visibility)  {
 vec3 lightDir = vec3(lvector);
 
 vec3 surfaceNormal = normal;
 float cosAngIncidence = dot(surfaceNormal, lightDir);
 cosAngIncidence = clamp(cosAngIncidence, 0.0, 1.0);
 
 vec3 viewDirection = normalize(-ppos);
 
 vec3 halfAngle = normalize(lightDir + viewDirection);
 float blinnTerm = dot(surfaceNormal, halfAngle);
 
 float normalDotEye = dot(normal, normalize(ppos));
 float fresnel = clamp(pow(1.0 + normalDotEye, 5.0),0.0,1.0);
 fresnel = fresnel*0.5 + 0.5 * (1.0-fresnel);
 float pi = 3.1415927;
 float n =  pow(1.8,gloss*13.0);
 return (pow(blinnTerm, n )*((n+8.0)/(8*pi)))*fresnel*visibility;
}

float diffuseorennayar(vec3 pos, vec3 lvector, vec3 normal, float spec, float roughness) {
	
    vec3 v=normalize(pos);
	vec3 l=normalize(lvector);
	vec3 n=normalize(normal);

	float vdotn=dot(v,n);
	float ldotn=dot(l,n);
	float cos_theta_r=vdotn; 
	float cos_theta_i=ldotn; 
	float cos_phi_diff=dot(normalize(v-n*vdotn),normalize(l-n*ldotn));
	float cos_alpha=min(cos_theta_i,cos_theta_r); // alpha=max(theta_i,theta_r);
	float cos_beta=max(cos_theta_i,cos_theta_r); // beta=min(theta_i,theta_r)

	float r2=roughness*roughness;
	float a=1.0-0.5*r2/(r2+0.33);
	float b_term;
	
	if(cos_phi_diff>=0.0) {
		float b=0.45*r2/(r2+0.09);
		b_term=b*sqrt((1.0-cos_alpha*cos_alpha)*(1.0-cos_beta*cos_beta))/cos_beta*cos_phi_diff;
		b_term = b*sin(cos_alpha)*tan(cos_beta)*cos_phi_diff;
	}
	else b_term= 0.0;

	return clamp(cos_theta_i*(a+b_term),0.0,1.0);
}

#ifdef CELSHADING
vec3 celshade(vec3 clrr) {
	//edge detect
	float d = edepth(texcoord.xy);
	float dtresh = 1/(far-near)/5000.0;	
	vec4 dc = vec4(d,d,d,d);
	vec4 sa;
	vec4 sb;
	sa.x = edepth(texcoord.xy + vec2(-pw,-ph)*BORDER);
	sa.y = edepth(texcoord.xy + vec2(pw,-ph)*BORDER);
	sa.z = edepth(texcoord.xy + vec2(-pw,0.0)*BORDER);
	sa.w = edepth(texcoord.xy + vec2(0.0,ph)*BORDER);
	
	//opposite side samples
	sb.x = edepth(texcoord.xy + vec2(pw,ph)*BORDER);
	sb.y = edepth(texcoord.xy + vec2(-pw,ph)*BORDER);
	sb.z = edepth(texcoord.xy + vec2(pw,0.0)*BORDER);
	sb.w = edepth(texcoord.xy + vec2(0.0,-ph)*BORDER);
	
	vec4 dd = abs(2.0* dc - sa - sb) - dtresh;
	dd = vec4(step(dd.x,0.0),step(dd.y,0.0),step(dd.z,0.0),step(dd.w,0.0));
	
	float e = clamp(dot(dd,vec4(0.5f,0.5f,0.5f,0.5f)),0.0,1.0);
	return clrr*e;
}
#endif

float waterH(vec2 posxz) {

vec2 movement = vec2(-abs(frameTimeCounter/2000.-0.5),-abs(frameTimeCounter/1000.-0.5));
vec2 movement2 = vec2(abs(frameTimeCounter/2000.-0.5),abs(frameTimeCounter/1000.-0.5));
vec2 movement3 = vec2(-abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/2000.-0.5));
vec2 movement4 = vec2(abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/2000.-0.5));

vec2 coord = (posxz/600)+(movement);
vec2 coord1 = (posxz/599.9)+(movement2);
vec2 coord2 = (posxz/599.8)+(movement);
vec2 coord3 = (posxz/599.7)+(movement2);

float noise = texture2D(noisetex,fract(coord.xy/2.0)).x/8;
noise += texture2D(noisetex,fract(coord1.xy)).x/16.0;
noise += texture2D(noisetex,fract(coord2.xy*2.0)).x/8;
noise += texture2D(noisetex,fract(coord3.xy*2.0)).x/8;

return noise;
}

float getnoise(vec2 pos) {
return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));

}

#ifdef WATER_CAUSTIC

vec3 waterCaustic(vec3 fposition,vec3 color) {

vec2 movement = vec2(-abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5));
vec2 movement2 = vec2(abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5));
vec2 movement3 = vec2(abs(frameTimeCounter/1000.-0.5),-abs(frameTimeCounter/1000.-0.5));
vec2 movement4 = vec2(-abs(frameTimeCounter/1000.-0.5),abs(frameTimeCounter/1000.-0.5));
	
vec3 underwaterpos = vec3(texcoord.st, texture2D(depthtex1, texcoord.st).r);
underwaterpos = nvec3(gbufferProjectionInverse * nvec4(underwaterpos * 2.0 - 1.0));
vec4 worldpositionuw = gbufferModelViewInverse * vec4(underwaterpos,1.0);	
vec3 wpos = (worldpositionuw.xyz + cameraPosition.xyz);

vec2 coord = (wpos.xz/(270*CAUSTIC_SIZE))+(movement*(4*CAUSTIC_SPEED));
vec2 coord1 = (wpos.xz/(269.9*CAUSTIC_SIZE))+(movement2*(4*CAUSTIC_SPEED));
vec2 coord2 = (wpos.xz/(269.8*CAUSTIC_SIZE))+(movement3*(4*CAUSTIC_SPEED));
vec2 coord3 = (wpos.xz/(269.7*CAUSTIC_SIZE))+(movement4*(4*CAUSTIC_SPEED));

float noise = texture2D(noisetex,fract(coord.xy/2.0)).x;
noise += texture2D(noisetex,fract(coord.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord1.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord2.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord3.xy)).x/2.0;


float causticstrength = max((noise-1.2),0.0);
float wca = (0.05/CAUSTIC_STRENGHT);
float caustic = (1.0 - (pow(wca,causticstrength)));
vec3 caustic_color = ivec3(ambient_color)/255.0/2.2;	//coloring caustics
vec3 wc = mix(color,caustic_color,caustic);

return wc;
}

#endif

float genDirtyLens (vec2 texcoord) {
	vec2 lens = vec2(0.0, aspectRatio);
	float noise = texture2D(noisetex,(texcoord+lens)*4).x;
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;	
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;
	noise += texture2D(noisetex,(texcoord+lens)*8).x/4;	
	float lensstrength = max(noise-1.8,0.0);
	float wlens = 0.1;
	float LensD = (1.0 - (pow(wlens,lensstrength)));
	LensD *= clamp((eyeBrightness.y-220)/15.0,0.0,1.0);
	return LensD;
	}
	

/* DRAWBUFFERS:31 */

void main() {
	
	fragpos = nvec3(gbufferProjectionInverse * nvec4(fragpos * 2.0 - 1.0));
	
	#ifndef DYNAMIC_HANDLIGHT
	handlight = 0.9;
	#endif
	
	vec2 newtc = texcoord.xy;
	
	float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13500.0)/300.0,0.0,1.0) + clamp((time-22500.0)/300.0,0.0,1.0)-clamp((time-23400.0)/300.0,0.0,1.0));	//fading between sun/moon shadows
	float night = clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-23000.0)/200.0,0.0,1.0);
	float day = clamp((time-22000.0)/300.0,0.0,1.0)-clamp((time-13000.0)/200.0,0.0,1.0);
	
	float shadowexit = float(aux.g > 0.1 && aux.g < 0.3);
	float land = float(aux.g > 0.04);
	float iswater = float(aux.g > 0.04 && aux.g < 0.07);
	float translucent = float(aux.g > 0.3 && aux.g < 0.5);
	float hand = float(aux.g > 0.75 && aux.g < 0.85);
	float issky = -land;
	float emissive = float(aux.g > 0.58 && aux.g < 0.62);
	
	if (hand > 0.9) {
	handlight = (handItemLight*10.0*HANDLIGHT_AMOUNT);
	}
	
	float roughness = mix(1.0-(pow(specular.g,2.0))+specular.b+iswet*specular.g*0.5,0.05,iswater);
	if (specular.r+specular.g+specular.b < 1.0/255.0 && iswater < 0.09) roughness = 0.0;
	
	float fresnel_pow = pow(1.0-(specular.b+specular.g)/2.0,1.25+iswet*0.75)*3.5;
	
	
	vec3 color = texture2D(gcolor, texcoord.st).rgb;
	color = pow(color,vec3(2.2));
	
	float NdotL = dot(lightVector,normal);
	float NdotUp = dot(normal,upVec);
	
	vec4 fragposition = gbufferProjectionInverse * vec4(newtc.s * 2.0f - 1.0f, newtc.t * 2.0f - 1.0f, 2.0f * pixeldepth - 1.0f, 1.0f);
	fragposition /= fragposition.w;
	
	float shading = 1.0f;
	vec3 radiance = vec3(0.5);
	float spec = 0.0;

	float dist = length(fragposition.xyz);

	float shadingsharp = 0.0f;
	
	
	vec4 worldposition = vec4(0.0);
	vec4 worldpositionraw = vec4(0.0);
	
	worldposition = gbufferModelViewInverse * fragposition;	
	
    float horizon = abs(worldposition.y - texcoord.y);
	float horizon2 = (worldposition.y - texcoord.y);
	
	
	float limit = max(pow(max(1.0 - horizon/600.0, 0.01), 8.0)-0.1, 0.0)*transition_fading*(1.0-TimeSunrise)*(1.0-TimeSunset);
	float limit_ss_sr = max(pow(max(1.0 - horizon/900.0, 0.01), 8.0)-0.1, 0.0)*transition_fading*(1.0-TimeNoon)*(1.0-TimeMidnight);
	float limit_ss_sr2 = max(pow(max(1.0 - horizon/900.0, 0.01), 8.0)-0.1, 0.0)*transition_fading*(1.0-TimeNoon)*(1.0-TimeMidnight);
	float limit_ss_sr3 = (max(pow(max(1.0 - horizon/150.0, 0.01), 8.0)-0.1, 0.0)*transition_fading*(1.0-TimeNoon)*(1.0-TimeMidnight))*1.1;
	float limit_ss_sr3_fix = (max(pow(max(1.0 - horizon2/700.0, 0.01), 8.0)-0.1, 0.0))*1.1;
	
	float SkyGradient = max(pow(max(1.0 - horizon/2500.0, 0.01), 8.0)-0.1, 0.0)*(1.0-limit_ss_sr2);
    SkyGradient = clamp(SkyGradient, 0.15, 1.0);
	
	vec3 limitcss = vec3(88,1,0)/70;
	vec3 limitcss2 = vec3(1,100,1)/400;
	vec3 limitcss3 = (vec3(4,58,84)/200);
	
	vec3 limitcsr = vec3(88,1,0)/70;
	vec3 limitcsr2 = vec3(0,200,1)/400;
	vec3 limitcsr3 = (vec3(4,58,84)/200);
	
	vec3 skycolor = vec3(ambient_color+1.8);
	vec3 skycolor_grad = vec3(0.5,0.5,1)/4;
	
	vec3 limit3_fix = vec3(limitcss3)/2;
	
	vec3 limitcn = vec3(1,1,1.5)/6;
	vec3 limitcnoon = vec3(98,169,244)/400;
	
	
	if (land < 0.1 && isEyeInWater < 0.9) {
		color.rgb *= (skycolor*0.75  * SkyGradient);
		color.rgb = mix(color.rgb, skycolor * 0.02*(10*TimeMidnight)*(1-TimeNoon)*(1-TimeSunrise)*(1-TimeSunset), limit);
		
		//fake atmospheric scattering/////////////////////////////////////////////////////////////////////////////////
		
		if (limit_ss_sr3_fix < 0.99) {
			
		color.rgb += (((limitcsr)*limit_ss_sr*(1-limit_ss_sr3_fix))*TimeSunrise*transition_fading)*(1-limit_ss_sr3)*(1*+limit_ss_sr2);	
		color.rgb -= ((((skycolor)*0.2)*limit_ss_sr*(1-limit_ss_sr3_fix))*TimeSunrise*transition_fading)*(1-limit_ss_sr3)*(1*+limit_ss_sr2);			 	
																													
		color.rgb += (((limitcss)*limit_ss_sr*(1-limit_ss_sr3_fix))*TimeSunset*transition_fading)*(1-limit_ss_sr3)*(1*+limit_ss_sr2);	
		color.rgb -= ((((skycolor)*0.2)*limit_ss_sr*(1-limit_ss_sr3_fix))*TimeSunset*transition_fading)*(1-limit_ss_sr3)*(1*+limit_ss_sr2);				
																													
		color.rgb += (((limitcsr2)*limit_ss_sr2*(1-limit_ss_sr3_fix))*TimeSunrise*transition_fading)*(1-limit_ss_sr3);					
																													
		color.rgb += (((limitcss2)*limit_ss_sr2*(1-limit_ss_sr3_fix))*TimeSunset*transition_fading)*(1-limit_ss_sr3);	

		}		
		
				
		color.rgb += (((limit3_fix)*limit_ss_sr3)*TimeSunrise*TimeSunset*transition_fading)*(1-limit_ss_sr2)*(1-limit_ss_sr);
		color.rgb -= ((((skycolor)*0.05)*limit_ss_sr3)*TimeSunset*transition_fading)*(1*+limit_ss_sr2)*(1-limit_ss_sr);
		
																													
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		color.rgb -= ((skycolor)*0.2)*limit*TimeMidnight;
		color.rgb += ((limitcn*0.1)*limit)*TimeMidnight;
		
		color.rgb += ((limitcnoon)*limit)*TimeNoon*transition_fading;
		
		color.rgb += (vec3(limitcn)/50)*TimeMidnight;
		
		//ToneMapping For Sky//
		
		color.r = color.r + ((color.g + color.b)/2.0)*-(0.2-(0.2*TimeSunrise)-(0.2*TimeSunset))*transition_fading;
		color.g = color.g + ((color.r + color.b)/2.0)*-(0.1-(0.1*TimeSunrise)-(0.1*TimeSunset))*transition_fading;
		color.b = color.b + ((color.r + color.g)/2.0)*-(0.2-(0.2*TimeSunrise)-(0.2*TimeSunset))*transition_fading;
		
		color.rgb -= color.rgb*0.5*(1-TimeMidnight)*(1-TimeSunrise*0.25)*(1-TimeSunset*0.25);
		
		color.g -= color.g*0.5*TimeNoon;
		
		//End of Tone For Sky//
		}
		
			
	/*
	vec2 uv = ( gl_FragCoord.xy / 500.0);

	float t =  1.0 / horizon / (sin( uv.y + sin(uv.y*0.0) + sin(uv.y*0.0) * uv.y ) * 0.025)*transition_fading;
	vec3 Skycolorgrad = (vec3(ambient_color)*0.5);
	t = clamp(t, 0.25, 1.0);
	
	if (land < 0.9){
	color = vec3(Skycolorgrad)*t;
	color = clamp(color,0.0,1.0)*t;
	}
	*/
		
#ifdef WATER_REFRACT
	
	if (iswater > 0.9) {
	vec3 posxz = worldposition.xyz + cameraPosition.xyz;
	
	float deltaPos = 0.1;
	float h0 = waterH(posxz.xz);
	float h1 = waterH(posxz.xz + vec2(deltaPos,0.0));
	float h2 = waterH(posxz.xz + vec2(-deltaPos,0.0));
	float h3 = waterH(posxz.xz + vec2(0.0,deltaPos));
	float h4 = waterH(posxz.xz + vec2(0.0,-deltaPos));
	
	float xDelta = ((h1-h0)+(h0-h2))/deltaPos;
	float yDelta = ((h3-h0)+(h0-h4))/deltaPos;

	
	float refMult = (REFRACT_MULT/1000)-dot(normal,normalize(fragposition).xyz)*0.0035;
	
	vec3 refract = normalize(vec3(xDelta,yDelta,1.0-pow(abs(xDelta+yDelta),2.0)));
	vec4 rA = texture2D(gcolor, texcoord.st + refract.xy*refMult);
	rA.rgb = pow(rA.rgb,vec3(2.2));
	vec4 rB = texture2D(gcolor, texcoord.st);
	rB.rgb = pow(rB.rgb,vec3(2.2));
	float mask = texture2D(gaux1, texcoord.st + refract.xy*refMult).g;
	mask =  float(mask > 0.04 && mask < 0.07);
	color.rgb = rA.rgb*mask + rB.rgb*(1-mask);
}
	
#endif

	if (land > 0.9) {
	
	worldposition = shadowModelView * worldposition;
	float comparedepth = -worldposition.z;
	worldposition = shadowProjection * worldposition;
	worldposition /= worldposition.w;
	
	float distb = sqrt(worldposition.x * worldposition.x + worldposition.y * worldposition.y);
	float distortFactor = (1.0f - SHADOW_MAP_BIAS) + distb * SHADOW_MAP_BIAS;
	worldposition.xy *= 1.0f / distortFactor;
	worldposition = worldposition * 0.5f + 0.5f;
	int vpsize = 0;
	float diffthresh = 1.0*distortFactor+iswater+translucent;
	float isshadow = 0.0;
	float ssample;

	float distof = clamp(1.0-dist/shadowDistance ,0.0,1.0);
	float distof2 = clamp(1.0-dist/(shadowDistance *0.75),0.0,1.0);
	float shadow_fade = clamp(distof*12.0,0.0,1.0);
	float sss_fade = pow(distof2,0.2);
	float step = 1.0/shadowMapResolution*(2.0+rainStrength*10.0);
	if (isEyeInWater < 0.9) {
		if (dist < shadowDistance) {
			if (shadowexit > 0.1 && isEyeInWater < 0.9) {
				shading = 1.0;
			}
			
			else {
			
			#ifdef SHADOW_FILTER
				#ifdef LQ_SHADOW_FILTER
				for(int i = 0; i < 25; i++){
					shadingsharp += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + circle_offsets[i]*step*SHADOW_FILTER_AMOUNT).z) * (256.0)), 0.0, diffthresh)/(diffthresh));
				}
				shadingsharp /= 25.0;
				#endif
				
				#ifdef HQ_SHADOW_FILTER
				for(int i = 0; i < 30; i++){
					shadingsharp += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + circle_offsets[i]*step*SHADOW_FILTER_AMOUNT).z) * (256.0)), 0.0, diffthresh)/(diffthresh));
				}
				shadingsharp /= 20.0;
				
				#endif
				
				shading = 1.0-shadingsharp;
				isshadow = 1.0;
				
				
			#endif
			
			#ifndef SHADOW_FILTER
				vec2 smcoord = floor(worldposition.st*shadowMapResolution+0.5)/shadowMapResolution;
				shading = (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st).z) * (256.0 - 0.05)), 0.0, diffthresh)/(diffthresh));
				shading += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + vec2(step,-step)).z) * (256.0 - 0.05)), 0.0, diffthresh)/(diffthresh));
				shading += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + vec2(-step,step)).z) * (256.0 - 0.05)), 0.0, diffthresh)/(diffthresh));
				shading += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + vec2(-step,-step)).z) * (256.0 - 0.05)), 0.0, diffthresh)/(diffthresh)) ;
				shading += (clamp(comparedepth - (0.05 + (texture2D(shadow, worldposition.st + vec2(step,step)).z) * (256.0 - 0.05)), 0.0, diffthresh)/(diffthresh));
				shading = 1.0-shading/5.0;
			#endif
			}
			
			
			
			
		}
	}
	
	float ao = 1.0;
	
#ifdef SSAO

	if (land > 0.9 && iswater < 0.9 && hand < 0.9) {
	
	
		vec3 norm = texture2D(gnormal,texcoord.xy).rgb*2.0-1.0;
		vec3 projpos = convertScreenSpaceToWorldSpace(texcoord.xy,pixeldepth); 
		
		float progress = 0.0;
		ao = 0.0;
		
		float projrad = clamp(distance(convertCameraSpaceToScreenSpace(projpos + vec3(ssaorad,ssaorad,ssaorad)).xy,texcoord.xy),7.5*pw,60.0*pw);
		
		for (int i = 1; i < nbdir; i++) {
			for (int j = 1; j < sampledir; j++) {
				vec2 samplecoord = vec2(cos(progress),sin(progress))*(j/sampledir)*projrad + texcoord.xy;
				float sample = texture2D(gdepthtex,samplecoord).x;
				vec3 sprojpos = convertScreenSpaceToWorldSpace(samplecoord,sample);
				float angle = pow(min(1.0-dot(norm,normalize(sprojpos-projpos)),1.0),2.0);
				float dist = pow(min(abs(ld(sample)-ld(pixeldepth)),0.015)/0.015,2.0);
				float temp = min(dist+angle,1.0);
				ao += pow(temp,3.0);
				//progress += (1.0-temp)/nbdir*3.14;
			}
			progress = i*1.256;
		}
		
		ao /= (nbdir-1)*(sampledir-1);
		
		ao = pow(ao, 2.2);
	
	}
#endif
		
	float sss_transparency = mix(0,1,translucent);		//subsurface scattering amount
	float sunlight_direct = 1.0;
	float direct = 1.0;
	float sss = 0.0;
	vec3 npos = normalize(fragposition.xyz);
	float NdotL = 1.0;
	
		NdotL = dot(normal, lightVector);
		direct = NdotL;
		
		sunlight_direct = diffuseorennayar(fragposition.xyz, lightVector, normal, specmap, roughness+0.01);
		sunlight_direct = mix(sunlight_direct,0.5*SUNLIGHTAMOUNT,translucent*min(sss_fade+0.4,1.0));
	
		sss += pow(max(dot(npos, lightVector),0.0),10.0)*sss_transparency*clamp(-NdotL,0.0,1.0)*translucent*4.0;

	
	
	sss = mix(0.0,sss,sss_fade);
	shading = clamp(shading,0.0,1.0);
	
	
	float handLight = (handlight*1.0)/pow(length(fragposition.xyz),1.0)*diffuseorennayar(fragposition.xyz, -fragposition.xyz, normal, specmap, roughness+0.01);
	float handSpec = ctorspec(fragposition.xyz,-fragposition.xyz,normalize(normal),roughness+0.01,fresnel_pow)*handLight*1.0;
	
	vec3 uPos = vec3(.0);

	float uDepth = texture2D(depthtex1,texcoord.xy).x;
	uPos = nvec3(gbufferProjectionInverse * vec4(vec3(texcoord.xy,uDepth) * 2.0 - 1.0, 1.0));
	
	vec3 uVec = fragposition.xyz-uPos;
	float UNdotUP = abs(dot(normalize(uVec),normal));
	float depth = length(uVec)*UNdotUP;
	float sky_absorbance = mix(mix(1.0,exp(-depth/4.5),iswater),1.0,isEyeInWater);
	
	//Apply different lightmaps to image
	
	vec3 torchcolor = vec3(TORCH_COLOR)*2.5*TORCH_INTENSITY*(1-isEyeInWater*-2);
	
		vec3 Sunlight_lightmap = sunlight_color*mix(max(sky_lightmap-rainStrength*0.85,0.0),shading*(1.0-rainStrength*0.85),shadow_fade)*(1-isEyeInWater)*SUNLIGHTAMOUNT *sunlight_direct*transition_fading;
		
		float visibility = (dot(normal,normalize(upPosition))*0.05+0.95)*sky_lightmap;
		float bouncefactor = (dot(normal,normalize(upPosition))*0.5+0.5)*sky_lightmap;
		
		vec3 reflected_sunlight = SHADOW_DARKNESS*sky_lightmap*sunlight_color*max(-NdotL*0.6+1.4,0.0)*SUNLIGHTAMOUNT*radiance*ao*0.3;
		
		float handlightDistance = 13.0f;
		
		vec3 sky_light = SHADOW_DARKNESS*pow(ambient_color,vec3(1.2))*ao * mix(radiance*0.5,vec3(0.5),bouncefactor) * visibility * vec3(skycolor)*2.0;
		
		vec3 Torchlight_lightmap = (torch_lightmap+handlight*2.0*pow(max(handlightDistance-length(fragposition.xyz),0.0)/handlightDistance,4.0)*max(dot(-fragposition.xyz,normal),0.0)) *  torchcolor ;
		
		vec3 color_sunlight = Sunlight_lightmap;
		vec3 color_torchlight = Torchlight_lightmap;
		
		color += color*.5*translucent*(1-shading);
		color += color*translucent*(shading);

	
		//Add all light elements together
		color = (reflected_sunlight + SHADOW_DARKNESS*sky_light + MIN_LIGHT*ao + Sunlight_lightmap*ao + color_torchlight*ao  +  sss * sunlight_color * shading *(1.0-rainStrength*0.9)*transition_fading)*color + handSpec * torchcolor;
				if (isEyeInWater < 0.9) {
#ifdef WATER_CAUSTIC
		color += waterCaustic(fragpos.xyz,color.rgb)*iswater;
		
#endif
		
	vec3 Ucolor = normalize(vec3(ambient_color));
	
	color *= sky_absorbance;
	
	//water fog
	
	if (iswater > 0.9 && isEyeInWater < 0.9) 
	color = mix(Ucolor*length(ambient_color)*0.02*(1.0-TimeMidnight*0.9),color,exp(-depth/4));
		
	float gfactor = mix(0.0,1.0,iswater);
	
	spec =  Blinn_Phong(fragposition.xyz,lightVector,normal,fresnel_pow,gfactor,shading*sunlight_direct) * iswater * (1.0-isEyeInWater) * (1.0-TimeMidnight*0.97) * (1.0-rainx);
	}
	
	}	else if (isEyeInWater < 0.1 && (aux.g < 0.02) ){
				color = mix(color,(vec3(0.1,0.1,0.1)/2),rainStrength);
		
	}
	
	vec3 cloud_color = vec3(sunlight_color)*(1-TimeSunrise*-10)*(1-TimeSunset*-10)*(1-night) + (vec3(2,3,8)/395.0/2.5*(1-rainx*0.05))*night;
	
	//volumetric cone
	float volumetric_cone = pow(max(dot(normalize(fragpos),lightVector),0.0),2.5*2.5)*transition_fading;
	float volumetric_cone2 = pow(max(dot(normalize(fragpos),lightVector),0.0),2.5*3.5)*transition_fading;
	float volumetric_cone3 = pow(max(dot(normalize(fragpos),-lightVector),0.0),7.0)*transition_fading;
	
	//volumetric cone
	cloud_color += ambient_color + volumetric_cone*5.0*(1.0-TimeMidnight)*(1.0-TimeSunrise*-1.0)*(1.0-TimeSunset*-1.0);
	cloud_color += ambient_color + volumetric_cone2*1.0*(1.0-rainStrength)*TimeMidnight;
	cloud_color += ambient_color + volumetric_cone3*1.0*(1.0-rainStrength)*TimeMidnight;
	
	if (land < 0.1){
	#ifdef CLOUDS
	color.rgb += (cloud_color*0.3*(1-rainx*0.9) * getCloudNoiseTex(fragposition, 20, 1.25, 2.5));
	
	#endif
		}
	
#ifdef WATER_CAUSTIC

	if (land > 0.9 && hand < 0.1)
	color += waterCaustic(fragpos.xyz,color.rgb*1.0*(1.0-iswater))*isEyeInWater;
	
#endif

#ifdef CELSHADING
	if (land > 0.9 && iswater < 0.9) color = celshade(color);
#endif

	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
	tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 pos1 = tpos.xy/tpos.z;
	vec2 lightPos = pos1*0.5+0.5;

	#ifdef GODRAYS
	
	float gr = 0.0;
	
	float truepos = pow(clamp(dot(-lightVector,tpos.xyz)/length(tpos.xyz),0.0,1.0),0.25);
	
	if (truepos > 0.05) {	
		vec2 deltaTextCoord = vec2( texcoord.st - lightPos.xy );
		vec2 textCoord = texcoord.st;
		deltaTextCoord *= 1.0 /  float(NUM_SAMPLES) * density;
	
			float avgdecay = 0.0;
			float distx = abs(texcoord.x*aspectRatio-lightPos.x*aspectRatio);
			float disty = abs(texcoord.y-lightPos.y);
			float noise = getnoise(textCoord);
			
			for(int i=0; i < NUM_SAMPLES ; i++) {			
				textCoord -= deltaTextCoord;
				float sample = step(texture2D(gaux1, textCoord+ deltaTextCoord*noise*grnoise).r,0.0);
				gr += sample;
		}
	}
	#endif
	
	color = pow(color,vec3(1.0/2.0));
	color = clamp(color,0.001,1.0);
	gl_FragData[0] = vec4(color, spec);
	gl_FragData[1] = vec4(vec3((gr/NUM_SAMPLES)),1.0);
}
