#version 120

/*
Modified Chocapic13 Shader Lite By Airloocke42
Still In Progress
*/

/*-------------------------------------
---------Adjustable Variable-----------
-------------------------------------*/

//----------Shadows----------//

const int shadowMapResolution = 96;	
const float shadowDistance = 32.0f;	

#define SHADOW_DARKNESS 1.1	

//----------Shadows----------//

//----------Lighting----------//

#define DYNAMIC_HANDLIGHT		
#define SUNLIGHTAMOUNT 7.0	

vec3 torchcolor = vec3(0.6,0.32,0.1);	

#define TORCH_ATTEN 5.0		
#define TORCH_INTENSITY 8.0	

#define ATTENUATION 3.0
#define MIN_LIGHT 0.005

//----------Lighting----------//

//----------Visual----------//

#define GODRAYS
	const float density = 0.7;			
	const int NUM_SAMPLES = 5;		
	const float grnoise = 0.012;			
	
//----------Visual----------//

/*-------------------------------------
---------Adjustable Variable-----------
-------------------------------------*/

//----------Do Not Edit----------//

const float sunPathRotation = -40.0f;
const float wetnessHalflife = 500.0f;
const float drynessHalflife = 70.0f;

const int R8 = 0;
const int gdepthFormat = R8;
const bool generateShadowMipmap = false;
const bool shadowHardwareFiltering = true;

#define SHADOW_MAP_BIAS 0.80

//----------Do Not Edit----------//

varying vec4 texcoord;
varying vec3 lightVector;
varying vec3 sunlight_color;
varying vec3 ambient_color;
varying float handItemLight;

uniform sampler2D gcolor;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gnormal;
uniform sampler2DShadow shadow;
uniform sampler2D gaux1;


uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 shadowProjection;
uniform mat4 shadowModelView;
uniform vec3 sunPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform float near;
uniform float far;
uniform vec3 skyColor;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float aspectRatio;
uniform float frameTimeCounter;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;
uniform int fogMode;

vec2 texel = vec2(1.0/viewWidth, 1.0/viewHeight);

float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;

vec3 aux = texture2D(gaux1, texcoord.st).rgb, sunPos = sunPosition;
vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0f - 1.0f;

float pixeldepth = texture2D(depthtex0,texcoord.xy).x;
float handlight = handItemLight;
float torch_lightmap = pow(aux.b,TORCH_ATTEN)*TORCH_INTENSITY;

float sky_lightmap = pow(aux.r,ATTENUATION);
float iswet = wetness*pow(sky_lightmap,5.0)*sqrt(0.5+max(dot(normal,normalize(upPosition)),0.0));

float ctorspec(vec3 ppos, vec3 lvector, vec3 normal,float rough,float fpow) {

    vec3 pos = -normalize(ppos);
    vec3 cHalf = normalize(lvector + pos);

    float normalDotHalf = dot(normal, cHalf);
    float normalDotHalf2 = normalDotHalf * normalDotHalf;

    float roughness2 = rough;
    float exponent = -(1.0 - normalDotHalf2) / (normalDotHalf2 * roughness2);
    float e = 2.71828182846;
    float D = pow(e, exponent) / (roughness2 * normalDotHalf2 * normalDotHalf2);

    float normalDotEye = dot(normal, pos);
    float F = pow(1.0 - normalDotEye, fpow);

    float normalDotLight = dot(normal, lvector);
    float X = 2.0 * normalDotHalf / dot(pos, cHalf);
    float G = min(1.0, min(X * normalDotLight, X * normalDotEye));
    float pi = 3.1415927;
    float CookTorrance = (D*F*G)/(normalDotEye*pi);
	 
    return clamp(CookTorrance/pi,0.0,1.0);
}

float getnoise(vec2 pos) {
return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));

}

void main() {
	
	#ifndef DYNAMIC_HANDLIGHT
	handlight = 0.0;
	#endif

	float shadowexit = float(aux.g > 0.1 && aux.g < 0.3);
	float land = float(aux.g > 0.04);
	float iswater = float(aux.g > 0.04 && aux.g < 0.07);
	float translucent = float(aux.g > 0.3 && aux.g < 0.5);
	float hand = float(aux.g > 0.75 && aux.g < 0.85);

	float fresnel_pow = 5.0, shading = 0.0f, spec = 0.0;
	
	vec3 color = texture2D(gcolor, texcoord.st).rgb;
	color = pow(color,vec3(2.2)); color = pow(color,vec3(1.0+iswet*0.5));
	
	vec4 fragposition = gbufferProjectionInverse * vec4(texcoord.s * 2.0f - 1.0f, texcoord.t * 2.0f - 1.0f, 2.0f * pixeldepth - 1.0f, 1.0f);
	fragposition /= fragposition.w;

	float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13000.0)/300.0,0.0,1.0) + clamp((time-22800.0)/200.0,0.0,1.0)-clamp((time-23400.0)/200.0,0.0,1.0));	//fading between sun/moon shadows
	float night = clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-22800.0)/200.0,0.0,1.0);
	
	vec4 worldposition = vec4(0.0);
	vec4 worldpositionraw = vec4(0.0);
	
	worldposition = gbufferModelViewInverse * fragposition;	
	
        float horizon = abs(worldposition.y - texcoord.y);

	float skyPos = max(pow(max(1.0 - horizon/3500.0, 0.01), 8.0)-0.1, 0.0);
	      skyPos = clamp(skyPos, 0.25, 1.0);

	float vista = max(pow(max(1.0 - horizon/500.0, 0.01), 8.0)-0.1, 0.0);

	vec3 skyGradient = ((ambient_color*16 + sunlight_color*8)/16.0);

	if (land < 0.1 && night == 0) {
	color.rgb *= skyGradient * skyPos;
	color.rgb = mix(color.rgb, skyGradient * 0.6, vista);
	}

	float dist = length(fragposition.xyz);
	float distof = clamp(1.0-dist/shadowDistance,0.0,1.0);
	float distof2 = clamp(1.0-dist/(shadowDistance*0.75),0.0,1.0);
	float shadow_fade = clamp(distof*12.0,0.0,1.0), sss_fade = pow(distof2,0.2);
	
	/*--reprojecting into shadow space --*/
	
	float xzDistanceSquared = worldposition.x * worldposition.x + worldposition.z * worldposition.z;
	float yDistanceSquared  = worldposition.y * worldposition.y;
	
	worldpositionraw = worldposition;
	
	worldposition = shadowModelView * worldposition;
	float comparedepth = -worldposition.z;
	worldposition = shadowProjection * worldposition;
	worldposition /= worldposition.w;
	
	float distb = sqrt(worldposition.x * worldposition.x + worldposition.y * worldposition.y);
	float distortFactor = (1.0f - SHADOW_MAP_BIAS) + distb * SHADOW_MAP_BIAS;
	worldposition.xy *= 1.0f / distortFactor;
	worldposition = worldposition * 0.5f + 0.5f;

	/*---------------------------------*/
	
	float diffthresh = 1.0*distortFactor+iswater+translucent;
	float step = 2.0/shadowMapResolution*(1.0+rainStrength*5.0);
	
	shadow_fade = 1.0-clamp((max(abs(worldposition.x-0.5),abs(worldposition.y-0.5))*2.0-0.9),0.0,0.1)*10.0;

	if (land > 0.9 && isEyeInWater < 0.1) {

	if (sky_lightmap < 0.1) { shading = 0.0; } else {			
	shading = shadow2D(shadow,vec3(worldposition.st, worldposition.z-diffthresh/300)).x;
	}	

	float ao = 1.0;	
	
	float sss_transparency = mix(0.0,0.75,translucent);	
	float sunlight_direct = 1.0;

	vec3 npos = normalize(fragposition.xyz);
	
	float NdotL = dot(normal, lightVector);

	sunlight_direct = max(NdotL,0.0);
	
	sunlight_direct = mix(sunlight_direct,0.6,translucent*min(sss_fade+0.5,1.0));
	float sss = pow(max(dot(npos, lightVector),0.0),20.0)*sss_transparency*clamp(-NdotL,0.0,1.0)*translucent*8.0;

	sss = mix(0.0,sss,sss_fade);
	shading = clamp(shading,0.0,1.0);

	float handLight = 0.0;

	vec3 Sunlight_lightmap = sunlight_color*mix(max(sky_lightmap-rainStrength*0.95,0.0),shading*(1.0-rainStrength*0.95),shadow_fade)*SUNLIGHTAMOUNT *sunlight_direct*transition_fading;
	
	float visibility = sky_lightmap;
	float bouncefactor = (dot(normal,normalize(upPosition))*0.5+0.5)*sky_lightmap;
		
	vec3 reflected_sunlight = SHADOW_DARKNESS*sky_lightmap*sunlight_color*(max(-NdotL*0.3,0.0)+1.0)*ao*0.5*(1.0-rainStrength*0.95);
		
	vec3 sky_light = SHADOW_DARKNESS*ambient_color*vec3(0.8,0.8,1.0)*ao * mix(0.25,0.5,bouncefactor) * visibility*2.0;
		
	vec3 Torchlight_lightmap = (torch_lightmap + handLight) *  torchcolor ;
		
	vec3 color_sunlight = Sunlight_lightmap;
	vec3 color_torchlight = Torchlight_lightmap;

	color = (reflected_sunlight + sky_light + MIN_LIGHT*ao + Sunlight_lightmap + color_torchlight*ao  +  sss * sunlight_color * shading *(1.0-rainStrength*0.9)*transition_fading*5.0)*color ;

	float gfactor = mix(0.0,1.0,iswater);

	spec =  1.0-exp(-ctorspec(fragposition.xyz,lightVector,normalize(normal),0.02,fresnel_pow) *land * (1.0-isEyeInWater) * shading * (1.0-night*0.75)*gfactor);

	} else if (isEyeInWater < 0.1 && (aux.g < 0.02) ) { color = color*6.0; }

	if(aux.g > 0.02 && aux.g < 0.04) color *= 5.0;

/* DRAWBUFFERS:31 */

	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 pos1 = tpos.xy/tpos.z, lightPos = pos1*0.5+0.5;

	float gr = 0.0, truepos = pow(clamp(dot(-lightVector,tpos.xyz)/length(tpos.xyz),0,1),.5);		
	
	#ifdef GODRAYS
	if (truepos > 0.05) {	
	vec2 deltaTextCoord = vec2(texcoord.st - lightPos.xy), textCoord = texcoord.st;
	deltaTextCoord *= 1.0 /  float(NUM_SAMPLES) * density;
	
	float avgdecay = 0.0;
	float distx = abs(texcoord.x*aspectRatio-lightPos.x*aspectRatio);
	float disty = abs(texcoord.y-lightPos.y);
	vec2 noise = vec2(getnoise(textCoord),getnoise(-textCoord.yx+0.05));
			
	for(int i = 0; i < NUM_SAMPLES; i++) {			
		textCoord -= deltaTextCoord;
	float sample = step(texture2D(gaux1, textCoord+ textCoord*noise*grnoise).g,0.01);
		gr += sample;
		}
	}
	#endif

	color = clamp(color/16.0,0.0,1.0);

	gl_FragData[0] = vec4(color, spec);
	gl_FragData[1] = vec4(vec3((gr/NUM_SAMPLES)),1.0);
}