#version 120

varying vec4 texcoord;
varying vec3 lightVector;
varying vec3 sunlight_color;
varying vec3 ambient_color;
varying float handItemLight;

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform int worldTime;
uniform int heldItemId;
uniform int heldBlockLightValue;
uniform float rainStrength;
uniform float wetness;


	////////////////////sunlight color////////////////////
	////////////////////sunlight color////////////////////
	////////////////////sunlight color////////////////////
	const ivec4 ToD[25] = ivec4[25](ivec4(0,1.0,1.25,2), //hour,r,g,b
							ivec4(1,1.0,1.25,2),
							ivec4(2,1.0,1.25,2),
							ivec4(3,1.0,1.25,2),
							ivec4(4,1.0,1.25,2),
							ivec4(5,1.0,1.25,2),
							ivec4(6,135,50,10),
							ivec4(7,135,55,30),
							ivec4(8,150,100,60),
							ivec4(9,160,120,80),
							ivec4(10,160,120,80),
							ivec4(11,160,120,80),
							ivec4(12,160,120,80),
							ivec4(13,160,120,80),
							ivec4(14,160,120,80),
							ivec4(15,160,120,80),
							ivec4(16,150,100,60),
							ivec4(17,135,55,30),
							ivec4(18,135,50,10),
							ivec4(19,1.0,1.25,2),
							ivec4(20,1.0,1.25,2),
							ivec4(21,1.0,1.25,2),
							ivec4(22,1.0,1.25,2),
							ivec4(23,1.0,1.25,2),
							ivec4(24,1.0,1.25,2)); 

	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	const ivec4 ToD2[25] = ivec4[25](ivec4(0,8,15,25), //hour,r,g,b
							ivec4(1,8,15,25),
							ivec4(2,8,15,25),
							ivec4(3,8,15,25),
							ivec4(4,8,15,25),
							ivec4(5,8,15,25),
							ivec4(6,21.20,21.0,60.25),
							ivec4(7,25.20,50.0,90.25),
							ivec4(8,35.20,60.0,141.25),
							ivec4(9,61.20,90.0,141.25),
							ivec4(10,91.20,90.0,141.25),
							ivec4(11,91.20,90.0,141.25),
							ivec4(12,91.20,90.0,141.25),
							ivec4(13,91.20,90.0,141.25),
							ivec4(14,91.20,90.0,141.25),
							ivec4(15,61.20,90.0,141.25),
							ivec4(16,35.20,60.0,141.25),
							ivec4(17,25.20,50.0,90.25),
							ivec4(18,21.20,21.0,60.25),
							ivec4(19,8,15,25),
							ivec4(20,8,15,25),
							ivec4(21,8,15,25),
							ivec4(22,8,15,25),
							ivec4(23,8,15,25),
							ivec4(24,8,15,25));

//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
void main() {
	
	gl_Position = ftransform();
	
	texcoord = gl_MultiTexCoord0;

	if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}
	
	else {
		lightVector = normalize(moonPosition);
	}
	

	handItemLight = 0.0;
	if (heldItemId == 50) {
		// torch
		handItemLight = 0.5;
	}
	
	else if (heldItemId == 76 || heldItemId == 94) {
		// active redstone torch / redstone repeater
		handItemLight = 0.1;
	}
	
	else if (heldItemId == 89) {
		// lightstone
		handItemLight = 1.0;
	}
	
	else if (heldItemId == 10 || heldItemId == 11 || heldItemId == 51) {
		// lava / lava / fire
		handItemLight = 0.5;
	}
	
	else if (heldItemId == 91) {
		// jack-o-lantern
		handItemLight = 0.7;
	}
	
	else if (heldItemId == 327) {
		//lava bucket
		handItemLight = 1.5;
	}
	
		else if (heldItemId == 385) {
		//fire charger
		handItemLight = 0.2;
	}
	
		else if (heldItemId == 138) {
		//Beacon
		handItemLight = 1.0;
	}
	
		else if (heldItemId == 169) {
		//Sea lantern
		handItemLight = 1.0;
	}
	
	

	

	float hour = worldTime/1000.0+6.0;
	if (hour > 24.0) hour = hour - 24.0;

							
	ivec4 temp = ToD[int(floor(hour))];
	ivec4 temp2 = ToD[int(floor(hour)) + 1];
	
	sunlight_color = mix(vec3(temp.yzw),vec3(temp2.yzw),(hour-float(temp.x))/float(temp2.x-temp.x))/255.0f;
							
	ivec4 tempa = ToD2[int(floor(hour))];
	ivec4 tempa2 = ToD2[int(floor(hour)) + 1];
	
	ambient_color = mix(vec3(tempa.yzw),vec3(tempa2.yzw),(hour-float(tempa.x))/float(tempa2.x-tempa.x))/255.0f;
	
}

