#version 120

varying vec4 texcoord;
varying vec3 sunlight;
varying vec3 lightVector;
varying vec3 ambient_color;

varying vec4 color;

uniform int worldTime;
uniform float rainStrength;
uniform vec3 sunPosition;
uniform vec3 moonPosition;

//raining
float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;

	const ivec4 ToD[25] = ivec4[25](ivec4(0,1,4.5,10), //hour,r,g,b
							ivec4(1,1,4.5,10),
							ivec4(2,1,4.5,10),
							ivec4(3,1,4.5,10),
							ivec4(4,1,4.5,10),
							ivec4(5,1,4.5,10),
							ivec4(6,130,01,0),
							ivec4(7,130,05,02),
							ivec4(8,130,20,05),
							ivec4(9,130,30,05),
							ivec4(10,130,40,10),
							ivec4(11,130,40,10),
							ivec4(12,130,50,15),
							ivec4(13,130,40,10),
							ivec4(14,130,40,10),
							ivec4(15,130,30,05),
							ivec4(16,130,20,05),
							ivec4(17,130,05,02),
							ivec4(18,130,01,0),
							ivec4(19,1,4.5,10),
							ivec4(20,1,4.5,10),
							ivec4(21,1,4.5,10),
							ivec4(22,1,4.5,10),
							ivec4(23,1,4.5,10),
							ivec4(24,1,4.5,10));

							
							
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	////////////////////ambient color////////////////////
	const ivec4 ToD2[25] = ivec4[25](ivec4(0,30,40,60), //hour,r,g,b
							ivec4(1,30,40,60),
							ivec4(2,30,40,60),
							ivec4(3,30,40,60),
							ivec4(4,30,40,60),
							ivec4(5,30,40,60),
							ivec4(6,90,90,180),
							ivec4(7,90,100,180),
							ivec4(8,90,120,180),
							ivec4(9,90,140,190),
							ivec4(10,90,140,200),
							ivec4(11,90,140,200),
							ivec4(12,90,140,200),
							ivec4(13,90,140,200),
							ivec4(14,90,140,200),
							ivec4(15,90,140,190),
							ivec4(16,90,120,180),
							ivec4(17,90,100,180),
							ivec4(18,90,90,180),
							ivec4(19,30,40,60),
							ivec4(20,30,40,60),
							ivec4(21,30,40,60),
							ivec4(22,30,40,60),
							ivec4(23,30,40,60),
							ivec4(24,30,40,60));
							
							
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////

void main() {
	
		if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}
	
	else {
		lightVector = normalize(moonPosition);
	}
	
	gl_Position = ftransform();
	
	texcoord = gl_MultiTexCoord0;
	
	//sunlight color
	float hour = worldTime/1000.0+6.0;
	if (hour > 24.0) hour = hour - 24.0;

							
	ivec4 temp = ToD[int(floor(hour))];
	ivec4 temp2 = ToD[int(floor(hour)) + 1];
	
	sunlight = mix(vec3(temp.yzw),vec3(temp2.yzw),(hour-float(temp.x))/float(temp2.x-temp.x))/255.0f;
	
	
	ivec4 tempa = ToD2[int(floor(hour))];
	ivec4 tempa2 = ToD2[int(floor(hour)) + 1];
	
	ambient_color = mix(vec3(tempa.yzw),vec3(tempa2.yzw),(hour-float(tempa.x))/float(tempa2.x-tempa.x))/255.0f;

	
}
