#version 120

/*



			███████ ███████ ███████ ███████ █
			█          █    █     █ █     █ █
			███████    █    █     █ ███████ █
			      █    █    █     █ █       
			███████    █    ███████ █       █

	Before you change anything here, please notice that you
	are allowed to modify my shaderpack ONLY for yourself!

	Please read my agreement for more informations!
		- http://bit.ly/1De7OOY

		
		
*/

//////////////////////////////////////////////////////////////
///////////////////// ADJUSTABLE FEATURES ////////////////////
//////////////////////////////////////////////////////////////

	#define LENS_EFFECTS

//	#define BLOOM	
		#define DYNAMIC_TONEMAPPING		

	#define DOF
//		#define TILT_SHIFT

	//#define SHAKING_CAMERA

//////////////////////////////////////////////////////////////
//////////////////////// GET MATERIAL ////////////////////////
//////////////////////////////////////////////////////////////

varying vec4 texcoord;

uniform sampler2D depthtex2;
uniform sampler2D gaux1;
uniform sampler2D gaux2;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 sunPosition;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;
uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;
uniform float centerDepthSmooth;
uniform int fogMode;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float timefract = worldTime;

vec3 sunPos = sunPosition;

//Raining
float rainStrength2 = clamp(wetness, 0.0f, 1.0f)/1.0f;

//Calculate Time of Day
float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

float luma(vec3 color) {
	return dot(color,vec3(0.299, 0.587, 0.114));
}

float A = 0.58;
float B = 0.23;
float C = 0.1;
float D = 0.2;
float E = 0.02;
float F = 0.3;
float W = 48.0;

vec3 Uncharted2Tonemap(vec3 x) {
	return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}
#ifdef DOF

	//hexagon pattern
	const vec2 hex_offsets[60] = vec2[60] (	vec2(  0.2165,  0.1250 ),
										vec2(  0.0000,  0.2500 ),
										vec2( -0.2165,  0.1250 ),
										vec2( -0.2165, -0.1250 ),
										vec2( -0.0000, -0.2500 ),
										vec2(  0.2165, -0.1250 ),
										vec2(  0.4330,  0.2500 ),
										vec2(  0.0000,  0.5000 ),
										vec2( -0.4330,  0.2500 ),
										vec2( -0.4330, -0.2500 ),
										vec2( -0.0000, -0.5000 ),
										vec2(  0.4330, -0.2500 ),
										vec2(  0.6495,  0.3750 ),
										vec2(  0.0000,  0.7500 ),
										vec2( -0.6495,  0.3750 ),
										vec2( -0.6495, -0.3750 ),
										vec2( -0.0000, -0.7500 ),
										vec2(  0.6495, -0.3750 ),
										vec2(  0.8660,  0.5000 ),
										vec2(  0.0000,  1.0000 ),
										vec2( -0.8660,  0.5000 ),
										vec2( -0.8660, -0.5000 ),
										vec2( -0.0000, -1.0000 ),
										vec2(  0.8660, -0.5000 ),
										vec2(  0.2163,  0.3754 ),
										vec2( -0.2170,  0.3750 ),
										vec2( -0.4333, -0.0004 ),
										vec2( -0.2163, -0.3754 ),
										vec2(  0.2170, -0.3750 ),
										vec2(  0.4333,  0.0004 ),
										vec2(  0.4328,  0.5004 ),
										vec2( -0.2170,  0.6250 ),
										vec2( -0.6498,  0.1246 ),
										vec2( -0.4328, -0.5004 ),
										vec2(  0.2170, -0.6250 ),
										vec2(  0.6498, -0.1246 ),
										vec2(  0.6493,  0.6254 ),
										vec2( -0.2170,  0.8750 ),
										vec2( -0.8663,  0.2496 ),
										vec2( -0.6493, -0.6254 ),
										vec2(  0.2170, -0.8750 ),
										vec2(  0.8663, -0.2496 ),
										vec2(  0.2160,  0.6259 ),
										vec2( -0.4340,  0.5000 ),
										vec2( -0.6500, -0.1259 ),
										vec2( -0.2160, -0.6259 ),
										vec2(  0.4340, -0.5000 ),
										vec2(  0.6500,  0.1259 ),
										vec2(  0.4325,  0.7509 ),
										vec2( -0.4340,  0.7500 ),
										vec2( -0.8665, -0.0009 ),
										vec2( -0.4325, -0.7509 ),
										vec2(  0.4340, -0.7500 ),
										vec2(  0.8665,  0.0009 ),
										vec2(  0.2158,  0.8763 ),
										vec2( -0.6510,  0.6250 ),
										vec2( -0.8668, -0.2513 ),
										vec2( -0.2158, -0.8763 ),
										vec2(  0.6510, -0.6250 ),
										vec2(  0.8668,  0.2513 ));

#endif

#ifdef TILT_SHIFT

	// lens properties with tilt shift
	const float focal = 0.3;
	float aperture = 0.3;	
	const float sizemult = 1.0;
	
#else 

	// normal lens properties
	const float focal = 0.012;
	float aperture = 0.009;	
	const float sizemult = 100.0;

#endif


#ifdef LENS_EFFECTS

	float distratio(vec2 pos, vec2 pos2, float ratio) {
		float xvect = pos.x*ratio-pos2.x*ratio;
		float yvect = pos.y-pos2.y;
		return sqrt(xvect*xvect + yvect*yvect);
	}
	
	float PI = 3.14159265358979323846264;
	float angle = 90.0;
	float rad_angle = angle*PI/180.0;

	//circle position pattern (vec2 coordinate, size)
	const vec3 pattern[16] = vec3[16](	vec3(0.1,0.1,0.02),
										vec3(-0.12,0.07,0.02),
										vec3(-0.11,-0.13,0.02),
										vec3(0.1,-0.1,0.02),
									
										vec3(0.07,0.15,0.02),
										vec3(-0.08,0.17,0.02),
										vec3(-0.14,-0.07,0.02),
										vec3(0.15,-0.19,0.02),
									
										vec3(0.012,0.15,0.02),
										vec3(-0.08,0.17,0.02),
										vec3(-0.14,-0.07,0.02),
										vec3(0.02,-0.17,0.021),
									
										vec3(0.10,0.05,0.02),
										vec3(-0.13,0.09,0.02),
										vec3(-0.05,-0.1,0.02),
										vec3(0.1,0.01,0.02)
									);	
									
	float gen_circular_lens(vec2 center, float size) {
		return 1.0-pow(min(distratio(texcoord.xy,center,aspectRatio),size)/size,10.0);
	}

	vec2 noisepattern(vec2 pos) {
		return vec2(abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f)),abs(fract(sin(dot(pos.yx ,vec2(18.9898f,28.633f))) * 4378.5453f)));
	} 
	
	float yDistAxis (in float degrees) {
	
		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z;
			 lightPos = (lightPos + 1.0f)/2.0f;
			 
		return abs((lightPos.y-lightPos.x*(degrees))-(texcoord.y-texcoord.x*(degrees)));
		
	}
	
	float smoothCircleDist (in float lensDist) {

		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z*lensDist;
			 lightPos = (lightPos + 1.0f)/2.0f;
			 
		return distratio(lightPos.xy, texcoord.xy, aspectRatio);
		
	}
	
	float cirlceDist (float lensDist, float size) {
	
		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z*lensDist;
			 lightPos = (lightPos + 1.0f)/2.0f;
			 
		return pow(min(distratio(lightPos.xy, texcoord.xy, aspectRatio),size)/size,10.0);
	}

#endif

#ifdef SHAKING_CAMERA

	vec2 shaking_camera = vec2(0.0015 * sin(frameTimeCounter * 2.0), 0.0015 * cos(frameTimeCounter * 3.0));

#else

	vec2 shaking_camera = vec2(0.0, 0.0);

#endif

#ifdef DYNAMIC_TONEMAPPING

	float dynamicTonemapping(float dTDayValue, float dTNightValue) {
	
		float dTDay = dTDayValue * (TimeSunrise + TimeNoon + TimeSunset);
		float dTNight = dTNightValue * TimeMidnight;
			
		float dTBrightness = dTDay + dTNight;
			  
		return (pow(eyeBrightnessSmooth.y / 255.0, 6.0f) * 1.0 + dTBrightness);
	
	}

#endif











//////////////////////////////////////////////////////////////
/////////////////////////// MAIN /////////////////////////////
//////////////////////////////////////////////////////////////

void main() {

	vec2 fake_refract = vec2(sin(frameTimeCounter*1.7 + texcoord.x*50.0 + texcoord.y*25.0),cos(frameTimeCounter*2.5 + texcoord.y*100.0 + texcoord.x*25.0)) * isEyeInWater;
	vec3 color = texture2D(gaux2, texcoord.st + shaking_camera + fake_refract * 0.005).rgb;
	
	float plum = luma(color.rgb);

#ifdef DOF
	// Calculate pixel Circle of Confusion that will be used for bokeh depth of field
	float z = ld(texture2D(depthtex2, texcoord.st + shaking_camera).r) * far;
	float focus = ld(texture2D(depthtex2, vec2(0.5)).r) * far;
	float pcoc = min(abs(aperture * (focal * (z - focus)) / (z * (focus - focal))) * sizemult,pw * 10.0);
	
	#ifdef TILT_SHIFT
		pcoc *= 0.5;
	#else
		pcoc *= 1.0;
	#endif
	
	vec4 sample = vec4(0.0);
	vec3 bcolor = vec3(0.0);
	
	vec4 fringe_sample = vec4(0.0);
	vec3 fringecolor = vec3(0.0);

	for ( int i = 0; i < 60; i++) {
		if (isEyeInWater > 0.9) {
			sample = texture2D(gaux2, texcoord.xy + shaking_camera + hex_offsets[i]*0.01*vec2(1.0,aspectRatio) + fake_refract * 0.005);
			bcolor += sample.rgb;
		} else {
			sample			 = texture2D(gaux2, texcoord.xy + shaking_camera + hex_offsets[i] * pcoc * vec2(1.0,aspectRatio));
			fringe_sample	 = texture2D(gaux2, texcoord.xy + shaking_camera + hex_offsets[i] * pcoc * 1.3 * vec2(1.0,aspectRatio));
			
			fringecolor	 += fringe_sample.rgb;
			bcolor		 += sample.rgb;
		}
	}
	
	color.rgb 	= bcolor / 60.0;
	color.r 	= fringecolor.r / 60.0;
	
#endif
	
/*
#ifdef DOF
	
	// Calculate pixel Circle of Confusion that will be used for bokeh depth of field
	float z = ld(texture2D(depthtex2, texcoord.st).r)*far;
	float focus = ld(texture2D(depthtex2, vec2(0.5)).r)*far;
	float pcoc = min(abs(aperture * (focal * (z - focus)) / (z * (focus - focal)))*sizemult,pw*10.0);
	
	#ifdef TILT_SHIFT
		pcoc *= 0.5;
	#else
		pcoc *= 1.0;
	#endif
	
	vec4 sample = vec4(0.0);
	vec3 bcolor = vec3(0.0);
	float nb = 0.0;
	vec2 bcoord = vec2(0.0);

	for ( int i = 0; i < 60; i++) {
		if (isEyeInWater > 0.9) {
			sample = texture2D(gaux2, texcoord.xy + hex_offsets[i]*0.01*vec2(1.0,aspectRatio) + fake_refract * 0.007);
			bcolor += sample.rgb;
		} else {
			sample = texture2D(gaux2, texcoord.xy + hex_offsets[i]*pcoc*vec2(1.0,aspectRatio) + fake_refract * 0.007);
			bcolor += sample.rgb;
		}
	}
	
	color.rgb = bcolor/60.0;
	
#endif
*/
#ifdef BLOOM
		
	vec4 bl_sample = vec4(0.0);
	vec3 bl_color = vec3(0.0);

	for ( int i = 0; i < 60; i++) {
		bl_sample = texture2D(gaux2, texcoord.xy + shaking_camera + hex_offsets[i] / 25.0 * vec2(1.0,aspectRatio));
			
		bl_color += bl_sample.rgb * 0.7;
	}
	
	#ifdef DYNAMIC_TONEMAPPING

		bl_color = bl_color / dynamicTonemapping(0.8, 1.0);
			
	#endif
	
	color.rgb += bl_color / 60.0;
	
#endif

	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 lightPos = tpos.xy/tpos.z;
		lightPos = (lightPos + 1.0f)/2.0f;

    float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
    float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);

    float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/500.0,0.0,1.0)-clamp((time-13000.0)/500.0,0.0,1.0) + clamp((time-22500.0)/100.0,0.0,1.0)-clamp((time-23300.0)/200.0,0.0,1.0));

    float sunvisibility = min(texture2D(gaux2,vec2(0.0)).a,1.0) * fading * transition_fading;
	float centerVisibility = 1.0 - clamp(distance(lightPos.xy, vec2(0.5, 0.5)) * 2.0, 0.0, 1.0);
		  centerVisibility *= sunvisibility;
		  
	float centerSize = 1.0 - clamp(distance(lightPos.xy, vec2(0.5, 0.5)) * 2.0, 0.0, 1.0);
	
#ifdef LENS_EFFECTS
	
    float dirtylens = 0.0;

    vec2 pos1 = noisepattern(vec2(0.6,-0.12));
    dirtylens += gen_circular_lens(pos1,0.05)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.3,-0.4));
    dirtylens += gen_circular_lens(pos1,0.015)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.8,-0.4));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.9,-0.2));
    dirtylens += gen_circular_lens(pos1,0.03)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.9,-0.6));
    dirtylens += gen_circular_lens(pos1,0.04)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.2,-0.8));
    dirtylens += gen_circular_lens(pos1,0.04)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.5,-0.9));
    dirtylens += gen_circular_lens(pos1,0.05)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.5,-0.95));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.6,-0.95));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.7,-0.1));
    dirtylens += gen_circular_lens(pos1,0.035)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.9,-0.1));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.2,-0.2));
    dirtylens += gen_circular_lens(pos1,0.037)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.4,-0.2));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.95,-0.8));
    dirtylens += gen_circular_lens(pos1,0.03)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.99,-0.8));
    dirtylens += gen_circular_lens(pos1,0.04)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.99,0.99));
    dirtylens += gen_circular_lens(pos1,0.03)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.2,0.9));
    dirtylens += gen_circular_lens(pos1,0.043)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.4,0.99));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.69,0.999));
    dirtylens += gen_circular_lens(pos1,0.02)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.69,0.99));
    dirtylens += gen_circular_lens(pos1,0.025)*sunvisibility;
	
    pos1 = noisepattern(vec2(-0.9,0.3));
    dirtylens += gen_circular_lens(pos1,0.03)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.9,0.3));
    dirtylens += gen_circular_lens(pos1,0.04)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.1,0.1));
    dirtylens += gen_circular_lens(pos1,0.05)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.1,0.15));
    dirtylens += gen_circular_lens(pos1,0.035)*sunvisibility;
	
    pos1 = noisepattern(vec2(0.15,0.13));
    dirtylens += gen_circular_lens(pos1,0.025)*sunvisibility;
	
	// Fix, that the particles are visible on the moon position at daytime
	float truepos = 0.0f;
	
	if ((worldTime < 13000 || worldTime > 23000) && sunPos.z < 0) truepos = 1.0 * (TimeSunrise + TimeNoon + TimeSunset); 
	if ((worldTime < 23000 || worldTime > 13000) && -sunPos.z < 0) truepos = 1.0 * TimeMidnight; 

	if (sunvisibility > 0.01) {
	
		float visibility = max(pow(max(1.0 - smoothCircleDist(1.0)/1.25,0.1),2.0)-0.1,0.0);
		
		vec3 lenscolorSunrise = vec3(2.52, 1.0, 0.0) * TimeSunrise;
		vec3 lenscolorNoon = vec3(2.52, 1.0, 0.3) * TimeNoon;
		vec3 lenscolorSunset = vec3(2.52, 1.0, 0.0) * TimeSunset;
		vec3 lenscolorNight = vec3(0.5, 0.7, 1.3) * TimeMidnight;
			
		vec3 lenscolor = lenscolorSunrise + lenscolorNoon + lenscolorSunset + lenscolorNight;
			
		color += (dirtylens*visibility*truepos)*0.1*lenscolor*(1.0-rainStrength*1.0);
		color += (dirtylens*visibility*truepos)*0.1*lenscolor*(1.0-rainStrength*1.0);
	}
	
	if ((worldTime < 13000 || worldTime > 23000) && sunPos.z < 0 && isEyeInWater < 0.9) {
	
		float dist = distance(texcoord.st, vec2(0.5, 0.5));
		
		// Sunrays
		if (sunvisibility > 0.13) {
		
			float visibility = max(pow(max(1.0 - smoothCircleDist(1.0)/0.8,0.1),5.0)-0.1,0.0);
		
			vec3 lenscolorSunrise = vec3(2.52, 1.0, 0.0) * TimeSunrise;
			vec3 lenscolorNoon = vec3(2.52, 1.0, 0.3) * TimeNoon;
			vec3 lenscolorSunset = vec3(2.52, 1.0, 0.0) * TimeSunset;
			
			vec3 lenscolor = lenscolorSunrise + lenscolorNoon + lenscolorSunset;
			
			float lens_strength = 1.0 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float sunray1 = max(pow(max(1.0 - yDistAxis(1.5)/1.0,0.1),10.0)-0.6,0.0);
			float sunray2 = max(pow(max(1.0 - yDistAxis(-1.5)/1.0,0.1),10.0)-0.6,0.0);
			float sunray3 = max(pow(max(1.0 - yDistAxis(5.0)/2.2,0.1),10.0)-0.6,0.0);
			float sunray4 = max(pow(max(1.0 - yDistAxis(-5.0)/2.2,0.1),10.0)-0.6,0.0);
			
			float sunrays = sunray1 + sunray2 + sunray3 + sunray4;
			
			color += lenscolor * sunrays * visibility * sunvisibility * (1.0-rainStrength*1.0);
		}

		// Anamorphic Lens
		if (sunvisibility > 0.13) {
		
			float visibility = max(pow(max(1.0 - smoothCircleDist(1.0)/1.3,0.1),1.0)-0.1,0.0);
		
			vec3 lenscolorSunrise = vec3(2.52, 1.0, 0.0) * TimeSunrise;
			vec3 lenscolorNoon = vec3(2.52, 1.0, 0.3) * TimeNoon;
			vec3 lenscolorSunset = vec3(2.52, 1.0, 0.0) * TimeSunset;
			vec3 lenscolorNight = vec3(0.5, 0.7, 1.3) * TimeMidnight;
			
			vec3 lenscolor = lenscolorSunrise + lenscolorNoon + lenscolorSunset + lenscolorNight;
			
			float lens_strength = 0.8 ;
			lenscolor *= lens_strength;
			
			float anamorphic_lens = max(pow(max(1.0 - yDistAxis(0.0)/1.0,0.1),10.0)-0.5,0.0);
			color += anamorphic_lens * lenscolor * visibility * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Circle Lens 1
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(2.52, 1.0, 0.0) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 0.2 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.15, 0.07)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.2, 0.07)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.25, 0.07)/1.0,0.1),5.0)-0.1,0.0);
			
			float lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);
			
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Circle Lens 2
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(2.52, 1.0, 0.0) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 0.2 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.4, 0.13)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.5, 0.13)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.6, 0.13)/1.0,0.1),5.0)-0.1,0.0);
			
			float lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);
			
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Circle Lens 3
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(0.0, 2.55, 2.52) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 0.1 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.75, 0.09)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.8, 0.09)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.85, 0.09)/1.0,0.1),5.0)-0.1,0.0);
			
			float lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);
			
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Small point 1
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(2.55, 2.55, 0.0) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 3.0 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare = max(pow(max(1.0 - smoothCircleDist(-0.3)/1.0,0.1),5.0)-0.93,0.0);
			
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Small point 2
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(0.0, 2.55, 2.52) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 3.0 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare = max(pow(max(1.0 - smoothCircleDist(-0.85)/1.0,0.1),5.0)-0.93,0.0);
			
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		// Ring Lens 
		if (sunvisibility > 0.13) {
		
			vec3 lenscolor = vec3(2.52, 1.0, 0.0) * (TimeSunrise + TimeNoon + TimeSunset);
			
			float lens_strength = 0.3 / dynamicTonemapping(0.5, 1.0);
			lenscolor *= lens_strength;
			
			float lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.7, 0.5)/1.0,0.1),5.0)-0.1,0.0);
			float lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.9, 0.5)/1.0,0.1),5.0)-0.1,0.0);
			
			float lensFlare = clamp(lensFlare2 - lensFlare1, 0.0, 1.0);
			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0);
		}
		
		
	}
	
//rain drops on screen

	if (rainStrength > 0.01) {
		const float pi = 3.14159265359;
		float lightmap = pow(eyeBrightness.y/255.0, 6.0f);
		float fake_refract = 1.0-sin(worldTime/5.14159265359 + texcoord.x*30.0 + texcoord.y*30.0);
		float fake_refract2 = sin(worldTime/7.14159265359 + texcoord.x*20.0 + texcoord.y*20.0) * pow(eyeBrightness.y/255.0, 6.0f) * (1.0-TimeMidnight*0.7);
		vec3 watercolor = texture2D(gaux1, texcoord.st + fake_refract * 0.015 * lightmap).rgb;
		float raindrops = 0.0;
		float time2 = frameTimeCounter;

		float gen = cos(time2*pi)*0.5+0.5;
		vec2 pos = noisepattern(vec2(0.9347*floor(time2*0.5+0.5),-0.2533282*floor(time2*0.5+0.5)));
		raindrops += gen_circular_lens(pos,0.033)*gen*rainStrength;

		gen = cos(time2*pi)*0.5+0.5;
		pos = noisepattern(vec2(0.785282*floor(time2*0.5+0.5),-0.285282*floor(time2*0.5+0.5)));
		raindrops += gen_circular_lens(pos,0.033)*gen*rainStrength;

		gen = sin(time2*pi)*0.5+0.5;
		pos = noisepattern(vec2(-0.347*floor(time2*0.5+0.5),0.6847*floor(time2*0.5+0.5)));
		raindrops += gen_circular_lens(pos,0.033)*gen*rainStrength;

		gen = cos(time2*pi)*0.5+0.5;
		pos = noisepattern(vec2(0.3347*floor(time2*0.5+0.5),-0.2533282*floor(time2*0.5+0.5)));
		raindrops += gen_circular_lens(pos,0.033)*gen*rainStrength;

		gen = cos(time2*pi)*0.5+0.5;
		pos = noisepattern(vec2(0.385282*floor(time2*0.5+0.5),-0.285282*floor(time2*0.5+0.5)));
		raindrops += gen_circular_lens(pos,0.033)*gen*rainStrength;
		 
		if (isEyeInWater < 0.9) {
			color += abs(fake_refract2)/25*raindrops;
		}
	}
	
#endif
	
	if (sunvisibility > 0.01) {
		float imageBrightnessNormal = 0.01 * (TimeSunrise+TimeNoon+TimeSunset);
		float imageBrightnessNight = 1.0 * TimeMidnight;
		float imageBrightnessRain = 1.0 * rainStrength;
		
		float imageBrightness = imageBrightnessNormal + imageBrightnessNight + imageBrightnessRain;
		color.rgb = mix(color.rgb, color.rgb * imageBrightness, centerVisibility);
	}

	color = clamp(color,0.0,1.0);

	float white = luma(color);
	color = color*(1.0+pow(white,0.3))/(2.0-0.3);

	color = pow(color,vec3(2.2));

	//Tonemapping
	vec3 curr = Uncharted2Tonemap(color);

	vec3 whiteScale = 1.0f/Uncharted2Tonemap(vec3(W));
	color = curr*whiteScale;


    float dist = distance(texcoord.st, vec2(0.5, 0.5));
	dist = 0.75 - dist;
	
    color.r = color.r * dist;
    color.g = color.g * dist;
    color.b = color.b * dist;

	color.r = pow(color.r, 0.7);
	color.g = pow(color.g, 0.7);
	color.b = pow(color.b, 0.7);
	
    vec3 Gray = vec3(0.0, 0.3, 0.3);
    vec3 ColorScale = vec3(1.0, 1.0, 1.0);
    float Saturation = 1.3;

    // Color Matrix
    vec3 OutColor = color.rgb;
    
    // Offset & Scale
    OutColor = (OutColor * ColorScale);
    
    // Saturation
    float Luma = dot(OutColor, Gray);
    vec3 Chroma = OutColor - Luma;
    OutColor = (Chroma * Saturation) + Luma;
    
    color = OutColor;
	
	color *= 1.9;

	
#ifdef VINTAGE

	vec3 vintage_color = vec3(1.08, 1.19, 1.0);
	vec3 second_color = vec3(0.0, 0.02, 0.05);
	
	color.rgb = color.rgb * vintage_color + second_color;

#endif

color = pow(color,vec3(1.0/2.2));


	
	gl_FragColor = vec4(color,1.0);
	
}
