#version 120
#define MAX_COLOR_RANGE 48.0

//disabling is done by adding "//" to the beginning of a line.

//***************************ADJUSTABLE VARIABLES***************************//
//***************************ADJUSTABLE VARIABLES***************************//
//***************************ADJUSTABLE VARIABLES***************************//

//***************************VISUALS***************************//

#define VIGNETTE
	#define VIGNETTE_STRENGTH 1.0

#define LENS_EFFECTS
	#define LENS_STRENGTH 0.5	
	
#define RAIN_DROPS
	#define RAIN_LENS_STRENGTH 1.0

//***************************BLOOM***************************//

#define BLOOM								//do the "fog blur" in the same time
	#define B_TRESH 0.1				
	#define B_RAD 15.0					//sampling circle size multiplier, don't affect performance
	#define B_INTENSITY 0.5		//basic multiplier
	
//***************************DOF***************************//

#define DOF
	#define DOF_MULT 1.0
//#define TILT_SHIFT 					//to let everything look small. more for cinematic purposes
	#define TILT_SHIFT_MULT 1.0		//simple multiplier
#define FRINGE_DOF						//to give the dof a rainbow look
	#define FRINGE_AMOUNT 1.0		//the amound of fringe
//#define DISTANCE_BLUR					//to let the background fade out
	#define DISTANCE_BLUR_MULT 1.0	//simple multiplier
	#define DISTANCE_BLUR_DIST 1.0	//distance
	
//***************************COLORS***************************//
		
		
#define COLOR_CORRECTION

#define TONEMAP
	#define TONEMAP_CURVE 1.0

#define UNCHARTED2_TONEMAPTONEMAP
	
#define CONTRAST 0.35

#define GAMMA 0.5	//higher values means darker

//***************************EFFECTS***************************//						
	
//#define TV_SCREEN_EFFECT		//Just for fun. Enable to get like an old screen effect.

//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//



varying vec4 texcoord;
varying vec3 sunlight;

uniform sampler2D depthtex0;
uniform sampler2D gaux1;
uniform sampler2D gaux2;
uniform sampler2D gaux4;
uniform sampler2D texture;
uniform sampler2D noisetex;
uniform sampler2D gcolor;
uniform sampler2D gdepth;
uniform sampler2D composite;
uniform sampler2D gnormal;

uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
varying vec3 ambient_color;
varying vec3 moonlight;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;
uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;
varying float moonVisibility;
uniform float centerDepthSmooth;
vec3 sunPos = sunPosition;
uniform vec3 skyColor;
uniform int fogMode;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float timefract = worldTime;

//Raining
float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;
float wetx  = clamp(wetness, 0.0f, 1.0f);

//Calculate Time of Day
float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

float matflag = texture2D(gaux1,texcoord.xy).g;

float sky_lightmap = texture2D(gaux1,texcoord.xy).r;

vec3 aux = texture2D(gaux1, texcoord.xy).rgb;

vec4 Tc = texcoord;

// Standard depth function.
float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

float luma(vec3 color) {
	return dot(color,vec3(0.299, 0.587, 0.114));
}

#ifdef BLOOM
const vec2 offsets[30] = vec2[30]  (  vec2( 0.0000, 0.2500 ),
         vec2( -0.2165, 0.1250 ),
         vec2( -0.2165, -0.1250 ),
         vec2( -0.0000, -0.2500 ),
         vec2( 0.2165, -0.1250 ),
         vec2( 0.2165, 0.1250 ),
         vec2( 0.0000, 0.5000 ),
         vec2( -0.2500, 0.4330 ),
         vec2( -0.4330, 0.2500 ),
         vec2( -0.5000, 0.0000 ),
         vec2( -0.4330, -0.2500 ),
         vec2( -0.2500, -0.4330 ),
         vec2( -0.0000, -0.5000 ),
         vec2( 0.2500, -0.4330 ),
         vec2( 0.4330, -0.2500 ),
         vec2( 0.5000, -0.0000 ),
         vec2( 0.4330, 0.2500 ),
         vec2( 0.2500, 0.4330 ),
         vec2( 0.0000, 0.7500 ),
         vec2( -0.2565, 0.7048 ),
         vec2( -0.4821, 0.5745 ),
         vec2( -0.6495, 0.3750 ),
         vec2( -0.7386, 0.1302 ),
         vec2( -0.7386, -0.1302 ),
         vec2( -0.6495, -0.3750 ),
         vec2( -0.4821, -0.5745 ),
         vec2( -0.2565, -0.7048 ),
         vec2( -0.0000, -0.7500 ),
         vec2( 0.2565, -0.7048 ),
         vec2( 0.4821, -0.5745 ));
	
#endif

const vec2 cross_offset[36] = vec2[36]  (  vec2( 0.0, 0.1 ),
		vec2( 0.0, 0.15 ),
        vec2( 0.0, 0.2 ),
		vec2( 0.0, 0.25 ),
        vec2( 0.0, 0.3 ),
		vec2( 0.0, 0.35 ),
		vec2( 0.0, 0.4 ),
		vec2( 0.0, 0.45 ),
		vec2( 0.0, 0.5 ),
		vec2( -0.1, 0.0 ),
		vec2( -0.15, 0.0 ),
		vec2( -0.2, 0.0 ),
		vec2( -0.25, 0.0 ),
		vec2( -0.3, 0.0 ),
		vec2( -0.35, 0.0 ),
		vec2( -0.4, 0.0 ),
		vec2( -0.45, 0.0 ),
		vec2( -0.5, 0.0 ),
		vec2( 0.0, -0.1 ),
		vec2( 0.0, -0.15 ),
		vec2( 0.0, -0.2 ),
		vec2( 0.0, -0.25 ),
		vec2( 0.0, -0.3 ),
		vec2( 0.0, -0.35 ),
		vec2( 0.0, -0.4 ),
		vec2( 0.0, -0.45 ),
		vec2( 0.0, -0.5 ),
		vec2( 0.1, 0.0 ),
		vec2( 0.15, 0.0 ),
		vec2( 0.2, 0.0 ),
		vec2( 0.25, 0.0 ),
		vec2( 0.3, 0.0 ),
		vec2( 0.35, 0.0 ),
		vec2( 0.4, 0.0 ),
		vec2( 0.45, 0.0 ),
		vec2( 0.5, 0.0 ));
		
#ifdef TILT_SHIFT
const float focal = 2.0;
float aperture = 0.6;	
const float sizemult = 0.25*TILT_SHIFT_MULT;
#else			
const float focal = 0.015;
float aperture = 0.009;	
const float sizemult = 25.0*DOF_MULT;		
#endif

#ifdef DOF

//hexagon pattern
const vec2 hex_offsets[30] = vec2[30] (	vec2(  0.2165,  0.1250 ),
									vec2(  0.0000,  0.2500 ),
									vec2( -0.2165,  0.1250 ),
									vec2( -0.2165, -0.1250 ),
									vec2( -0.0000, -0.2500 ),
									vec2(  0.2165, -0.1250 ),
									vec2(  0.4330,  0.2500 ),
									vec2(  0.0000,  0.5000 ),
									vec2( -0.4330,  0.2500 ),
									vec2( -0.4330, -0.2500 ),
									vec2( -0.0000, -0.5000 ),
									vec2(  0.4330, -0.2500 ),
									vec2(  0.6495,  0.3750 ),
									vec2(  0.0000,  0.7500 ),
									vec2( -0.6495,  0.3750 ),
									vec2( -0.6495, -0.3750 ),
									vec2( -0.0000, -0.7500 ),
									vec2(  0.6495, -0.3750 ),
									vec2(  0.8660,  0.5000 ),
									vec2(  0.0000,  1.0000 ),
									vec2( -0.8660,  0.5000 ),
									vec2( -0.8660, -0.5000 ),
									vec2( -0.0000, -1.0000 ),
									vec2(  0.8660, -0.5000 ),
									vec2(  0.2163,  0.3754 ),
									vec2( -0.2170,  0.3750 ),
									vec2( -0.4333, -0.0004 ),
									vec2( -0.2163, -0.3754 ),
									vec2(  0.2170, -0.3750 ),
									vec2(  0.4333,  0.0004 ));

#endif

float A = 1.2;		
float B = 0.4;		
float C = 0.1;	

int iswater = int(matflag > 0.04 && matflag < 0.07);
int land = int(matflag < 0.03);

int hand  = int(matflag > 0.75 && matflag < 0.85);

float distratio(vec2 pos, vec2 pos2, float ratio) {
float xvect = pos.x*ratio-pos2.x*ratio;
float yvect = pos.y-pos2.y;

vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0 - 1.0;

return sqrt(xvect*xvect + yvect*yvect);
}

//circle position pattern (vec2 coordinate, size)
const vec3 pattern[16] = vec3[16](	vec3(0.1,0.1,0.02),
								vec3(-0.12,0.07,0.02),
								vec3(-0.11,-0.13,0.02),
								vec3(0.1,-0.1,0.02),
								
								vec3(0.07,0.15,0.02),
								vec3(-0.08,0.17,0.02),
								vec3(-0.14,-0.07,0.02),
								vec3(0.15,-0.19,0.02),
								
								vec3(0.012,0.15,0.02),
								vec3(-0.08,0.17,0.02),
								vec3(-0.14,-0.07,0.02),
								vec3(0.02,-0.17,0.021),
								
								vec3(0.10,0.05,0.02),
								vec3(-0.13,0.09,0.02),
								vec3(-0.05,-0.1,0.02),
								vec3(0.1,0.01,0.02)
								);
								
float gen_circular_lens(vec2 center, float size) {
return 1.0-pow(min(distratio(Tc.xy,center,aspectRatio),size)/size,3.0);
}

vec2 noisepattern(vec2 pos) {
return vec2(abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f)),abs(fract(sin(dot(pos.yx ,vec2(18.9898f,28.633f))) * 4378.5453f)));
} 

vec3 Uncharted2Tonemap(vec3 x) {
	float D = 0.09;		
	float E = 0.02;
	float F = 0.3;
	float W = MAX_COLOR_RANGE;
	/*--------------------------------*/
	return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}

vec3 genlens(vec3 lenscolor, float dist, float size, vec4 tpos, float sun) {

	vec2 lightPos = tpos.xy/tpos.z*dist; lightPos = (lightPos + 1.0f)/2.0f;	

    float lensFlare = max(pow(max(1 - pow(min(distratio(lightPos.xy, texcoord.xy, aspectRatio),size)/size,10.0)/1,0.1),5.0)-0.1,0);

    return clamp(lensFlare, 0.0, 1.0) * lenscolor * 0.5 * sun * (1.0-rainStrength);	
}


//VOID MAIN//

void main() {

	vec2 fake_refract = vec2(sin(frameTimeCounter*2.0 + Tc.x*0.0 + Tc.y*25.0),cos(frameTimeCounter*2.0 + Tc.y*0.0 + Tc.x*50.0)) *isEyeInWater ;
	
		float rainlens = 0.0;
		const float lifetime = 3.0;		
		float ftime = frameTimeCounter*2.0/lifetime;  

		float gen = 1.0-fract((ftime+0.5)*0.5);
		vec2 pos = (noisepattern(vec2(-0.94386347*floor(ftime*0.5+0.25),floor(ftime*0.5+0.25)))-0.5)*0.85+0.5;
		rainlens += gen_circular_lens(pos,0.04)*gen*rainStrength;

		gen = 1.0-fract((ftime+1.0)*0.5);
		pos = (noisepattern(vec2(0.9347*floor(ftime*0.5+0.5),-0.2533282*floor(ftime*0.5+0.5)))-0.5)*0.85+0.5;
		rainlens += gen_circular_lens(pos,0.023)*gen*rainStrength;

		gen = 1.0-fract((ftime+1.5)*0.5);
		pos = (noisepattern(vec2(0.785282*floor(ftime*0.5+0.75),-0.285282*floor(ftime*0.5+0.75)))-0.5)*0.85+0.5;
		rainlens += gen_circular_lens(pos,0.03)*gen*rainStrength;

		gen =  1.0-fract(ftime*0.5);
		pos = (noisepattern(vec2(-0.347*floor(ftime*0.5),0.6847*floor(ftime*0.5)))-0.5)*0.85+0.5;
		rainlens += gen_circular_lens(pos,0.05)*gen*rainStrength;
	
		rainlens *= clamp((eyeBrightness.y-220)/15.0,0.0,1.0);
		
	vec2 fake_refract2 = vec2(sin(frameTimeCounter*0.0 + Tc.x*0.0 + Tc.y*50.0),cos(frameTimeCounter*0.0 + Tc.y*0.0 + Tc.x*100.0)) *rainlens ;

	vec3 color = texture2D(gaux2, Tc.st + fake_refract * 0.005 + (fake_refract2 * 0.05 * rainlens)).rgb;

#ifdef DOF
	if (hand < 0.9) {
	//Calculate pixel Circle of Confusion that will be used for bokeh depth of field
	float z = ld(texture2D(depthtex0, Tc.st).r)*far;
	float focus = ld(centerDepthSmooth)*far;
	float pcoc = min(abs(aperture * (focal * (z - focus)) / (z * (focus - focal)))*sizemult,pw*10.0);		
	vec4 sample = vec4(0.0);
	vec3 bcolor = vec3(0.0);
	float nb = 0.0;
	vec2 bcoord = vec2(0.0);
	float disblur = 1-(exp(-pow(ld(texture2D(depthtex0, Tc.st).r)/(256.0*DISTANCE_BLUR_DIST)*far,4.0)*4.0));
	#ifdef DISTANCE_BLUR
	pcoc += min(disblur*pw*20.0*DISTANCE_BLUR_MULT,pw*20.0*DISTANCE_BLUR_MULT);
	#endif

	for ( int i = 0; i < 30; i++) {
		sample = texture2D(gaux2, Tc.xy + hex_offsets[i]*pcoc*vec2(1.0,aspectRatio) + fake_refract * 0.005 + fake_refract2 * 0.005);
		
		#ifdef FRINGE_DOF
		sample.r = texture2D(gaux2, Tc.xy + hex_offsets[i]*pcoc*vec2(1.0,aspectRatio) + vec2(0.75*FRINGE_AMOUNT*pcoc) + fake_refract * 0.005 + fake_refract2 * 0.005).r;
		sample.g = texture2D(gaux2, Tc.xy + hex_offsets[i]*pcoc*vec2(1.0,aspectRatio) + fake_refract * 0.005 + fake_refract2 * 0.005).g;
		sample.b = texture2D(gaux2, Tc.xy + hex_offsets[i]*pcoc*vec2(1.0,aspectRatio) - vec2(0.75*FRINGE_AMOUNT*pcoc) + fake_refract * 0.005 + fake_refract2 * 0.005).b;
		#endif
		
		bcolor += sample.rgb;
	}
	
	color.rgb = bcolor/30.0;
}
#endif
	
	float plum = luma(color.rgb);

#ifdef BLOOM
if (hand < 0.9) {
const int GL_LINEAR = 9729;
const int GL_EXP = 2048;
	vec3 blur = vec3(0.0);
	float depth_diff = clamp(pow(ld(texture2D(depthtex0, Tc.st).r)*4.0,0.8),0.0,1.0)+0.1;
	float fog = 0.0;
	fog = 1.0-clamp(exp(-ld(texture2D(depthtex0, Tc.st).r)),0.0,1.0);

			float scale = length(vec2(pw,ph));
			vec3 csample = vec3(0.0);
				for (int i= 0; i < 30; i++) {
				vec2 coords = offsets[i];
				vec3 sample = texture2D(gaux2,Tc.xy + coords*B_RAD*scale).rgb;
				csample += max(texture2D(gaux2,Tc.xy + coords*B_RAD*scale).rgb-plum*0.75-B_TRESH,0.0) * (length(coords)+0.6)/2.0;
				blur += sample;
			}
			
		
		//fog blurring with the distance
		color.rgb = mix(color,blur/30.0,depth_diff*isEyeInWater*0.4+fog*(1.0-isEyeInWater)*rainStrength);
		color += csample/30.0*B_INTENSITY;
	
	}
#endif

	float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13000.0)/300.0,0.0,1.0) + clamp((time-22800.0)/200.0,0.0,1.0)-clamp((time-23400.0)/200.0,0.0,1.0));

vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 pos1 = tpos.xy/tpos.z;
		vec2 lightPos = pos1*0.5+0.5;
		
		
		vec3 lightVector;
	if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	} else {
		lightVector = normalize(moonPosition);
	}

	float xdist = abs(lightPos.x-texcoord.x);
	float ydist = abs(lightPos.y-texcoord.y);
	float xydist = distance(lightPos.xy,Tc.xy);

	float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
	float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);

	float sunvisibility = min(texture2D(gaux2,vec2(0.0)).a*2.5,1.0) * (1.0-rainStrength*0.9) * fading * transition_fading;

	float truepos = pow(clamp(dot(-lightVector,tpos.xyz)/length(tpos.xyz),0.0,1.0),0.25);
	
	float centerdist = distance(lightPos.xy,vec2(0.5))/1.0;
	float sizemult = 2.0 + centerdist;
	float noise = fract(sin(dot(Tc.st ,vec2(18.9898f,28.633f))) * 4378.5453f)*0.1 + 0.9;
	
	float circles_lens = 0.0;
		
#ifdef LENS_EFFECTS

	if (sunvisibility > 0.05) {
	
if (xydist < 0.40) {

vec2 sun_to_center = lightPos-vec2(0.5);
float dir = abs(sin(length(sun_to_center)))*0.0+0.0;

for (int i = 0; i < 16; i++) {
vec3 carac = pattern[i]*2.5;

carac.z *= 1.0/2.5;
carac.x /= aspectRatio;
carac *= (1.0 + dir)/2.0;

vec2 coord = carac.xy * sizemult+ lightPos.xy;
float strength = sin(length(coord-vec2(0.5))*40.0)*0.5+0.5;
circles_lens += gen_circular_lens(coord,carac.z*1.75)*strength;

carac = pattern[i];
carac.x /= aspectRatio;
carac.yx *= (2.0 - dir)/2.5;

coord = -carac.yx * sizemult + lightPos.xy;
strength = sin(length(coord-vec2(0.5))*40.0)*0.5+0.5;
circles_lens += gen_circular_lens(coord,carac.z*1.66)*strength;

carac = pattern[i];
carac.x /= aspectRatio;
carac.yx *= (2.0 - dir)/1.5;

coord = -carac.yx * sizemult + lightPos.xy;
strength = sin(length(coord-vec2(0.5))*40.0)*0.5+0.5;
circles_lens += gen_circular_lens(coord,carac.z*1.66)*strength;

carac = pattern[i];
carac.x /= aspectRatio;
carac.yx *= (2.0 - dir)/0.5;

coord = -carac.yx * sizemult + lightPos.xy;
strength = sin(length(coord-vec2(0.5))*40.0)*0.5+0.5;
circles_lens += gen_circular_lens(coord,carac.z*1.66)*strength;
}
color += sunlight*vec3(circles_lens) * sunvisibility * noise * 0.1*(1.0-isEyeInWater)* truepos;
color += TimeMidnight*vec3(circles_lens)*sunvisibility*+0.03* truepos;
color += rainx*vec3(circles_lens)*-0.00* truepos;

circles_lens -= 0.1 * TimeSunrise;
circles_lens += 0.2 * TimeNoon;
circles_lens -= 0.1 * TimeSunset;

}


	float anamorphic_lens = exp(-ydist*ydist/0.0001)*exp(-xdist*xdist/0.1)*sunvisibility*(1-TimeMidnight*0.9) * (1-rainStrength);

	color.rgb += (vec3(0.0,0.2,1.0)*anamorphic_lens*LENS_STRENGTH*2)* truepos;
}

	float sun = sunvisibility;
	float h = TimeMidnight, r = rainStrength;

	if (sun > 0.05) {

	vec3 c0 = vec3(0.0,0.5,1)/2 * (1-h) * LENS_STRENGTH * truepos;
	vec3 c1 = vec3(0.5,0.1,0)/2 * (1-h) * LENS_STRENGTH * truepos;
	vec3 c2 = vec3(1,0.5,0.0)/2 * (1-h) * LENS_STRENGTH * truepos;
	vec3 c3 = vec3(0.0,1,1)/2 * (1-h) * LENS_STRENGTH * truepos;

	vec3 c4 = vec3(0.05,0.25,1)/4 * h * LENS_STRENGTH * truepos;
	
	vec3 cr = vec3(1,.1,.1)*4 * (1-h) * LENS_STRENGTH * truepos;
	vec3 cb = vec3(.1,.1,1)*8 * (1-h) * LENS_STRENGTH * truepos;
	vec3 cg = vec3(.1,1,.1)*4 * (1-h) * LENS_STRENGTH * truepos;
	
	//day
	
	//front
	color += genlens(c3, 0.95, 0.01, tpos, sun * (1-r));
	color += genlens(c1, 0.65, 0.02, tpos, sun * (1-r));
	color += genlens(c3+c1, 0.35, 0.08, tpos, sun * (1-r));
	color += genlens(c2, 0.05, 0.02, tpos, sun * (1-r));
	color += genlens(c1, -0.05, 0.01, tpos, sun * (1-r));
	color += genlens(c3, -0.35, 0.02, tpos, sun * (1-r));
	color += genlens(c1, -0.65, 0.01, tpos, sun * (1-r));
	color += genlens(c2, -0.95, 0.02, tpos, sun * (1-r));
	
	color += genlens(c0, 1.2, 0.01, tpos, sun * (1-r));
	color += genlens(c0, 0.9, 0.015, tpos, sun * (1-r));
	color += genlens(c0, 0.6, 0.02, tpos, sun * (1-r));
	color += genlens(c0, 0.3, 0.03, tpos, sun * (1-r));
	color += genlens(c0, -0.3, 0.03, tpos, sun * (1-r));
	color += genlens(c0, -0.6, 0.06, tpos, sun * (1-r));
	color += genlens(c0, -0.9, 0.09, tpos, sun * (1-r));
	color += genlens(c0, -1.3, 0.12, tpos, sun * (1-r));
	
	color += genlens(c0, -1.2, 0.16, tpos, sun * (1-r));
	color += genlens(c3, -1.5, 0.19, tpos, sun * (1-r));
	color += genlens(c1, -1.7, 0.22, tpos, sun * (1-r));
	
	
	
	//back
	color += genlens(c0, 1.4, 0.01, tpos, sun * (1-r));
	color += genlens(c0, 1.6, 0.015, tpos, sun * (1-r));
	color += genlens(c0, 1.9, 0.03, tpos, sun * (1-r));
	color += genlens(c3, 2.2, 0.05, tpos, sun * (1-r));
	
	//rings
	
	float ringsSize = 1.25;
	float ringsSize2 = 0.25;
	color += genlens(cr, -1.7, 1.0*ringsSize, tpos, sun * (1-r)) + -genlens(cr, -1.7, 0.97*ringsSize, tpos, sun * (1-r));
	color += genlens(cg, -1.7, 1.05*ringsSize, tpos, sun * (1-r))+ -genlens(cg, -1.7, 1.025*ringsSize, tpos, sun * (1-r));
	color += genlens(cb, -1.7, 1.1*ringsSize, tpos, sun * (1-r)) + -genlens(cb, -1.7, 1.075*ringsSize, tpos, sun * (1-r));
	
	color += genlens(cr, 1.0, 1.0*ringsSize2, tpos, sun * (1-r)) + -genlens(cr, 1.0, 0.97*ringsSize2, tpos, sun * (1-r));
	color += genlens(cg, 1.0, 1.05*ringsSize2, tpos, sun * (1-r))+ -genlens(cg, 1.0, 1.025*ringsSize2, tpos, sun * (1-r));
	color += genlens(cb, 1.0, 1.1*ringsSize2, tpos, sun * (1-r)) + -genlens(cb, 1.0, 1.075*ringsSize2, tpos, sun * (1-r));
	
	//night
	color += genlens(c4, -0.4, 0.01, tpos, sun * (1-r));
	color += genlens(c4, -0.9, 0.05, tpos, sun * (1-r));
	color += genlens(c4, -1.7, 0.1, tpos, sun * (1-r));
	
	
	
	}

#endif

#ifdef VIGNETTE

float dv = distance(Tc.st, vec2(0.5, 0.5));

dv *= VIGNETTE_STRENGTH;

dv = 0.9 - dv;

dv = pow(dv, 0.25);

dv *= 2.3;
dv -= 0.9;

color *= dv;
#endif

#ifdef COLOR_CORRECTION
	
	//Color changes depends on time//
	color.rgb -= color.rgb*0.05*TimeSunrise;
	color.rgb += color.rgb*0.05*TimeNoon;
	color.rgb -= color.rgb*0.05*TimeSunset;
	color.rgb -= color.rgb*0.05*TimeMidnight;
	
	color.b += color.b*0.1*TimeNoon;
	color.r -= color.r*0.1*TimeNoon;
	
	color.b += color.b*0.05*TimeSunrise;
	color.g += color.g*0.05*TimeSunrise;
	color.r += color.r*0.1*TimeSunrise;
	
	color.b += color.b*0.05*TimeSunset;
	color.g += color.g*0.05*TimeSunset;
	color.r += color.r*0.1*TimeSunset;
	
	color.b += color.b*0.2*TimeMidnight;
	color.g += color.g*0.1*TimeMidnight;
	color.r += color.r*0.1*TimeMidnight;
	
	color.r = color.r + ((color.b + color.g)/2.0)*0.1;
	color.g = color.g + ((color.b + color.r)/2.0)*0.1;
	color.b = color.b + ((color.r + color.g)/2.0)*0.1;

		
#endif

float white = luma(color);
color = color*(1.0+pow(white,CONTRAST))/(2.0-CONTRAST);

color = pow(color,vec3(2.2));

#ifdef TONEMAP
color = color / (color + TONEMAP_CURVE) * (2.0+TONEMAP_CURVE);
	color.r = pow(color.r, GAMMA);
	color.g = pow(color.g, GAMMA);
	color.b = pow(color.b, GAMMA);
#endif

#ifdef UNCHARTED2_TONEMAPTONEMAP
	vec3 curr = Uncharted2Tonemap(color);
	vec3 whiteScale = 1.03f/Uncharted2Tonemap(vec3(1.0));
	color = pow(curr*whiteScale,vec3(1/0.3*TONEMAP_CURVE));
#endif

#ifdef RAIN_DROPS
color += vec3((0.05-(0.04*TimeMidnight))*RAIN_LENS_STRENGTH)*rainlens;
#endif

#ifdef TV_SCREEN_EFFECT
vec2 poss = (texcoord.st);
vec3 posscolor = vec3(1);

poss *= 500.0;
poss -= (1.0* (frameTimeCounter/0.5) / pos.y);

color *= vec3(sin(cos(poss.y-0.5) * 3.14259)) + normalize(vec3(posscolor))*1.0;
#endif

color = pow(color,vec3(0.6));
color = color * 0.8;

	color.r = color.r*1.0;
    color.g = color.g*1.0; 
    color.b = color.b*1.0;
	
	gl_FragColor = vec4(color.rgb,1.0);
	
}
