#version 120
#define MAX_COLOR_RANGE 48.0

/*
		@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		@##############################################################@	
		@#															  #@
		@#		[][][][][] [][][][][] [][][][][] [][][][][] []   	  #@
		@#		[]	  	       []     []      [] []	     [] []        #@
		@#		[]	 	       []     []      [] []	     [] []  	  #@
		@#		[]		       []     []      [] []	     [] []     	  #@
		@#		[][][][][]     []     []      [] [][][][][] []   	  #@
		@#				[]     []     []      [] []	        []        #@
		@#				[]     []     []      [] []	        []        #@
		@#				[]     []     []      [] []	           		  #@
		@#		[][][][][]     []     [][][][][] []	        []        #@
		@#															  #@
		@##############################################################@
		@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
		
		
		BEFORE DO ANYTHING, READ THIS AGREEMENT FIRST :
		
		
		YOU ARE ALLOWED TO :
		
		- Make videos or pictures with my shaderpack
		- Modify it only for yourself
		- Earn money with it from your YouTube Videos
		- Share my shaderpack link
		
		YOU ARE NOT ALLOWED TO :
		
		- Rename it and claim my shaderpack as your own
		- Publish your modifications
*/


/*
!! DO NOT REMOVE !!
This code is from Life Nexus shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/
/*
Disable an effect by putting "//" before "#define" when there is no number after
You can tweak the numbers, the impact on the shaders is self-explained in the variable's name or in a comment
*/
///////////////////////////////	
//////////Motion Blur//////////
///////////////////////////////

//#define MOTIONBLUR

///////////////////////////////
/////////////Lens//////////////
///////////////////////////////

#define Lens
	#define Lens_Strength 1.0
///////////////////////////////
///////////////////////////////
///////////////////////////////

const bool Vintage 			= false;
const bool Second_Vintage	= true;

///////////////////////////////
///////////////////////////////
///////////////////////////////

	


///////////////////////////////
/////////Tonemapping///////////			
///////////////////////////////
	
 

///////////////////////////////
//END OF ADJUSTABLE VARIABLES//
///////////////////////////////

varying vec4 texcoord;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;
varying vec3 fcolor;

varying float eyeAdapt;

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

uniform sampler2D texBloom;
uniform sampler2D texRaw;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D depthtex2;
uniform sampler2D gnormal;
uniform sampler2D gdepth;
uniform sampler2D noisetex;
uniform sampler2D gaux1;
uniform sampler2D gaux2;
uniform sampler2D gaux3;
uniform sampler2D gaux4;
uniform sampler2D composite;

uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;

uniform vec4 bloomData;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferPreviousProjection;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;

uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;

uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;
uniform float screenCX;
uniform float screenCY;
uniform int fogMode;
vec3 sunPos = sunPosition;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float timefract = worldTime;

//Raining
float rainx = clamp(rainStrength, 0.0f, 2.0f)/2.0f;
float wetx  = clamp(wetness, 1.0f, 2.0f);

//Calculate Time of Day
float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

// Standard depth function.
float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

float luma(vec3 color) {
	return dot(color,vec3(0.299, 0.587, 0.114));
}




float distratio(vec2 pos, vec2 pos2) {
	float xvect = pos.x*aspectRatio-pos2.x*aspectRatio;
	float yvect = pos.y-pos2.y;
	return sqrt(xvect*xvect + yvect*yvect);
}
								
float gen_circular_lens(vec2 center, float size) {
	float dist=distratio(center,texcoord.xy)/size;
	return exp(-dist*dist);
}

vec2 noisepattern(vec2 pos) {
	return vec2(abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f)),abs(fract(sin(dot(pos.yx ,vec2(18.9898f,28.633f))) * 4378.5453f)));
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));
}

float cdist(vec2 coord) {
	return max(abs(coord.s-0.5),abs(coord.t-0.5))*2.0;
}



vec3 alphablend(vec3 c, vec3 ac, float a) {
vec3 n_ac = normalize(ac)*(1/sqrt(3.));
vec3 nc = sqrt(c*n_ac);
return mix(c,nc,a);
}
float smStep (float edge0,float edge1,float x) {
float t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
return t * t * (3.0 - 2.0 * t); }


float waterDrop (vec2 tc) {
	vec2 drop = vec2(0.0,fract(frameTimeCounter/750.0));
	tc.x *= 10;
	float noise = texture2D(noisetex,(tc+drop)/2).x;
	noise += texture2D(noisetex,(tc+drop)).x/2;
	noise += texture2D(noisetex,(tc+drop)*2).x/4;
	noise += texture2D(noisetex,(tc+drop)*4).x/8;	
	noise += texture2D(noisetex,(tc+drop*0.5)).x/2;
	noise += texture2D(noisetex,(tc+drop*0.5)*2).x/4;
	noise += texture2D(noisetex,(tc+drop*0.5)*4).x/8;	
	float dropstrength = max(noise-1.8,0.0);
	float wdrop = 0.1;
	float waterD = (1.0 - (pow(wdrop,dropstrength)));
	waterD *= clamp((eyeBrightness.y-220)/15.0,0.0,1.0)*rainStrength;
	return waterD;
}

float distratio(vec2 pos, vec2 pos2, float ratio) {
float xvect = pos.x*ratio-pos2.x*ratio;
float yvect = pos.y-pos2.y;
return sqrt(xvect*xvect + yvect*yvect);
}

#ifdef Lens
vec3 genlens(vec3 lenscolor, float dist, float size, vec4 tpos, float sun) {

	vec2 lightPos = tpos.xy/tpos.z*dist; lightPos = (lightPos + 1.0f)/2.0f;	

    float lensFlare = max(pow(max(1 - pow(min(distratio(lightPos.xy, texcoord.xy, aspectRatio),size)/size,10.0)/1,0.1),5.0)-0.1,0);

    return clamp(lensFlare, 0.0, 1.0) * lenscolor * 0.5 * sun * (1.0-rainStrength);	
}
#endif

//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////





void main() {

	const float pi = 3.14159265359;
    float rainlens = 0.0;
    const float lifetime = 7.0;		//water drop lifetime in seconds
	float ftime = frameTimeCounter*2.0/lifetime;  
    vec2 drop = vec2(0.0,fract(frameTimeCounter/20.0));

	vec2 fake_refract = vec2(sin(frameTimeCounter + texcoord.x*100.0 + texcoord.y*50.0),cos(frameTimeCounter + texcoord.y*100.0 + texcoord.x*50.0)) ;
	vec2 newTC = texcoord.st + fake_refract * 0.01 * (rainlens+isEyeInWater*0.25) + fake_refract * 0.09 * waterDrop(texcoord.xy/250);
	
	vec3 color = pow(texture2D(gaux2, newTC).rgb,vec3(2.2))*MAX_COLOR_RANGE;

	float fog = 1-(exp(-pow(ld(texture2D(depthtex0, newTC.st).r)/256.0*far,4.0-(2.7*rainStrength))*4.0));

	

	
#ifdef MOTIONBLUR


	float depth = texture2D(depthtex0, texcoord.st).x, num = 0.0075 * 2.0;
	
		vec4 currentPosition = vec4(texcoord.x * 2.0 - 1.0, texcoord.y * 2.0 - 1.0, 2.0 * depth - 1.0, 1.0);
	
		vec4 fragposition = gbufferProjectionInverse * currentPosition;
		fragposition = gbufferModelViewInverse * fragposition;
		fragposition /= fragposition.w;
		fragposition.xyz += cameraPosition;
	
		vec4 previousPosition = fragposition;
		previousPosition.xyz -= previousCameraPosition;
		previousPosition = gbufferPreviousModelView * previousPosition;
		previousPosition = gbufferPreviousProjection * previousPosition;
		previousPosition /= previousPosition.w;
	
		vec2 velocity = (currentPosition - previousPosition).st * num;

		int samples = 1;

		vec3 motion = color.rgb;
		vec2 coord = texcoord.st + velocity;

		for (int i = 0; i < 15; ++i, coord += velocity) {
		if (coord.s > 1.0 || coord.t > 1.0 || coord.s < 0.0 || coord.t < 0.0) {
		break;
		}
		motion += pow(texture2D(gaux2, coord).rgb, vec3(2.2));
		++samples;
		}
		color.rgb = motion/vec3(1.0);

	
	#endif


	color.xyz = ((1-(1-color.xyz/48.0)*(1-(color.rgb/48.0)*sqrt(luma(color.rgb/48.0))))*48.0);


	//draw rain
	vec4 rain = pow(texture2D(gaux4,newTC.xy)+0.0001,vec4(vec3(2.2),0.4))*vec4(ambient_color*0.4,1.0);
	color.rgb = alphablend(color,rain.rgb,rain.a);



	

if (Vintage){
vec3 vint_color = vec3(1.0, 0.73, 0.27);
vec3 vint2_color = vec3(0.012, 0.023, 0.034);
color.rgb = color.rgb*vint_color+vint2_color;

}	



if (Second_Vintage){
vec3 bvint_color = vec3(1.0, 1.0, 0.7);
vec3 bvint2_color = vec3(0.012, 0.023, 0.034);
color.rgb = color.rgb*bvint_color+bvint2_color;

}




	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
		tpos = vec4(tpos.xyz/tpos.w,1.0);
	vec2 pos1 = tpos.xy/tpos.z;
		vec2 lightPos = pos1*0.5+0.5;
		
	float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/300.0,0.0,1.0)-clamp((time-13000.0)/300.0,0.0,1.0) + clamp((time-22800.0)/200.0,0.0,1.0)-clamp((time-23400.0)/200.0,0.0,1.0));	

	float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
	float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);
	float fade = clamp(1.0-step(distof,0.08),0.0,1.0);
#ifdef Lens
	float sunvisibility = min(texture2D(gaux2,vec2(0.0)).a*2.5,1.0) * (1.0-rainStrength*0.9) * fading * transition_fading;

	float sun = sunvisibility*Lens_Strength;
	float h = TimeMidnight, r = rainStrength;

	if (sun*fade > 0.05) {

	vec3 c1 = vec3(0.1,0.6,.8) * (1-h), c2 = vec3(0.1,1.0,.3) * (1-h);
	vec3 c3 = vec3(0.1,1.0,.3) * (1-h), c4 = vec3(1.0,0.0,0.6) * (1-h);
	vec3 c5 = vec3(1.0,0.8,0.0) * (1-h), c6 = vec3(1.1,0.1,1.3) * (1-h);
	vec3 c7 = vec3(0.1,1.1,1.3) * (1-h), c8 = vec3(0.5,1.0,0.3) * (1-h);
	vec3 c9 = vec3(1.0,0.6,0.0) * (1-h), c10 = vec3(1.1,0.1,1.3) * (1-h);
	vec3 c11 = vec3(1.0,0.8,0.0) * (1-h), c12 = vec3(0.0,0.8,0.6) * (1-h);
	vec3 c13 = vec3(1.0,0.0,1.0) * (1-h), c14 = vec3(1.1,1.0,0.0) * (1-h);
	vec3 c15 = vec3(0.0,0.5,0.0) * (1-h), c16 = vec3(0.9,0.5,0.5) * (1-h);
	vec3 c17 = vec3(0.0,0.5,0.4) * (1-h), c18 = vec3(0.4,0.0,0.7) * (1-h);
	
	vec3 cr = vec3(1.0,0.0,0.0) * (1-h);
	vec3 cg = vec3(0.0,1.0,0.0) * (1-h);
	vec3 cb = vec3(0.0,0.0,1.0) * (1-h);
	
	vec3 cnr = vec3(0.5,0.0,0.0)/4 * h;
	vec3 cng = vec3(0.0,0.5,0.0)/4 * h;
	vec3 cnb = vec3(0.0,0.0,0.5)/4 * h;
	vec3 cn = vec3(0.0,0.1,0.2)/4 * h;
	
	color += genlens(c1, -0.65, 0.13, tpos, sun * (1-r));
	color += genlens(c2, -0.75, 0.07, tpos, sun * (1-r));
	color += genlens(c3, -0.50, 0.07, tpos, sun * (1-r));
	color += genlens(c4, -0.50, 0.02, tpos, sun * (1-r));
	color += genlens(c5, -0.47, 0.01, tpos, sun * (1-r));
	color += genlens(c6, -0.30, 0.05, tpos, sun * (1-r));
	color += genlens(c7, -0.20, 0.04, tpos, sun * (1-r));
	color += genlens(c8, -0.14, 0.03, tpos, sun * (1-r));	
	color += genlens(c9, -0.0, 0.009, tpos, sun * (1-r));	
	color += genlens(c10, -0.30, 0.05, tpos, sun * (1-r));	
	color += genlens(c11, 0.20, 0.02, tpos, sun * (1-r));
	color += genlens(c12, 0.10, 0.01, tpos, sun * (1-r));
	color += genlens(c13, 0.30, 0.02, tpos, sun * (1-r));
	color += genlens(c14, 0.40, 0.03, tpos, sun * (1-r));
	color += genlens(c15, 0.50, 0.04, tpos, sun * (1-r));
	color += genlens(c16, 2.2, 0.05, tpos, sun * (1-r));
	color += genlens(c17, 1.9, 0.03, tpos, sun * (1-r));
	color += genlens(c18, 1.6, 0.03, tpos, sun * (1-r));
	color += genlens(cn, -0.65, 0.13, tpos, sun * (1-r));
	color += genlens(cn, -0.30, 0.05, tpos, sun * (1-r));
	color += genlens(cn, -0.20, 0.04, tpos, sun * (1-r));
	color += genlens(cn, -0.14, 0.03, tpos, sun * (1-r));


	//Ring Lens
	color += genlens(cr, 1.0, 1.0*0.25, tpos, sun * (1-r)) - genlens(cr, 1.0, 0.97*0.25, tpos, sun * (1-r));
	color += genlens(cg, 1.0, 1.05*0.25, tpos, sun * (1-r)) - genlens(cg, 1.0, 1.025*0.25, tpos, sun * (1-r));
	color += genlens(cb, 1.0, 1.1*0.25, tpos, sun * (1-r)) - genlens(cb, 1.0, 1.075*0.25, tpos, sun * (1-r));
	color += genlens(cnr, 1.0, 1.0*0.25, tpos, sun * (1-r)) - genlens(cnr, 1.0, 0.97*0.25, tpos, sun * (1-r));
	color += genlens(cng, 1.0, 1.05*0.25, tpos, sun * (1-r)) - genlens(cng, 1.0, 1.025*0.25, tpos, sun * (1-r));
	color += genlens(cnb, 1.0, 1.1*0.25, tpos, sun * (1-r)) - genlens(cnb, 1.0, 1.075*0.25, tpos, sun * (1-r));	
	
	}
	
#endif	


color.rgb += color.rgb * clamp((-eyeBrightnessSmooth.y+220)/300.0,0.0,1.0)*4.0;


	color = clamp(pow(color,vec3(1.0/2.2)),0.0,1.0);

	     color.r = color.r*1.0;
         color.g = color.g*1.0; 
         color.b = color.b*1.2;


		
	

	gl_FragColor = vec4(color, 1.0);


}

